/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './gdbmhash.pmc'
 * by ../../tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_gdbmhash.h"
#include "pmc_default.h"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./gdbmhash.pmc"
/* gdbmhash.pmc
 *  Copyright (C) 2005-2010, Parrot Foundation.
 *  SVN Info
 *     $Id: gdbmhash.pmc 45192 2010-03-26 21:15:07Z petdance $
 *  Overview:
 *     These are the vtable functions for the GDBMHash PMC
 *  Data Structure and Algorithms:
 *  History:
 *  Notes:
 *     Please remove unneeded entries.
 *  References:

=head1 NAME

src/dynpmc/gdbmhash.pmc - GDBM PMC

=head1 DESCRIPTION

This is an interface to the GNU dbm library.

=head1 keys

On inserted and fetch, keys are converted to STRINGs.

=head2 store

PMC insert values are converted to STRINGs.

=head2 fetch

C<get_integer_keyed()> and C<get_number_keyed()> probably don't make
any sense, as integers usually can't be converted.

When a PMC is requested, a String PMC is returned.


=head2 Functions

=over 4

=cut

 */

#include <gdbm.h>
#include "parrot/extend.h"

typedef struct GDBM_FH {
    GDBM_FILE f;
} GDBM_FH;

#define PMC_dbfh(x) ((Parrot_GDBMHash_attributes *)PMC_data(x))->db_handle->f


/*

=item C<static STRING* make_hash_key(PARROT_INTERP, PMC *key)>

Returns a Parrot string for C<*key>.

=cut

*/

static STRING* make_hash_key(PARROT_INTERP, ARGIN(PMC * key))
{
    if (key)
        return VTABLE_get_string(interp, key);

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
        "Hash: Cannot use NULL key");
}
#line 98 "./gdbmhash.c"
static  void  Parrot_GDBMHash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  Parrot_GDBMHash_destroy(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_GDBMHash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_GDBMHash_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_GDBMHash_get_integer(PARROT_INTERP, PMC *pmc);
static  PMC*  Parrot_GDBMHash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void*  Parrot_GDBMHash_get_pointer(PARROT_INTERP, PMC *pmc);
static  STRING*  Parrot_GDBMHash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  void  Parrot_GDBMHash_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_GDBMHash_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value);
static  void  Parrot_GDBMHash_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value);
static  void  Parrot_GDBMHash_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value);
static  void  Parrot_GDBMHash_set_pointer(PARROT_INTERP, PMC *pmc, void *p);
static  void  Parrot_GDBMHash_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value);
static  void  Parrot_GDBMHash_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  void Parrot_GDBMHash_nci_open(PARROT_INTERP, PMC *pmc);
static  void Parrot_GDBMHash_nci_close(PARROT_INTERP, PMC *pmc);
PARROT_DYNEXT_EXPORT void    Parrot_GDBMHash_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_GDBMHash_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_GDBMHash_get_vtable(PARROT_INTERP);
PARROT_DYNEXT_EXPORT void    Parrot_GDBMHash_ro_class_init(PARROT_INTERP, int, int);
PARROT_DYNEXT_EXPORT VTABLE* Parrot_GDBMHash_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_DYNEXT_EXPORT VTABLE* Parrot_GDBMHash_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_GDBMHash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 369 "./gdbmhash.pmc"

    STRING* keystr;
    GDBM_FILE dbf = PMC_dbfh(pmc);
    datum key_gdbm;

    if (!key) return;
    if (!dbf) return;
    keystr = make_hash_key(interp, key);

    key_gdbm.dptr  = Parrot_str_to_cstring(interp, keystr);
    key_gdbm.dsize = strlen(key_gdbm.dptr);

    if (gdbm_exists(dbf, key_gdbm)) {
       gdbm_delete(dbf, key_gdbm);
    }

    Parrot_str_free_cstring(key_gdbm.dptr);

    return;
#line 145 "./gdbmhash.c"
}
static  void 
Parrot_GDBMHash_destroy(PARROT_INTERP, PMC *pmc)
{
#line 107 "./gdbmhash.pmc"

    Parrot_GDBMHash_attributes *attrs = PARROT_GDBMHASH(pmc);
    mem_gc_free(interp, attrs->db_handle);
    PMC_data(pmc) = NULL;
#line 155 "./gdbmhash.c"
}
static  INTVAL 
Parrot_GDBMHash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 340 "./gdbmhash.pmc"

    STRING* keystr;
    GDBM_FILE dbf = PMC_dbfh(pmc);
    datum key_gdbm;
    INTVAL ret;

    if (!key) return 0;
    if (!dbf) return 0;
    keystr = make_hash_key(interp, key);

    key_gdbm.dptr  = Parrot_str_to_cstring(interp, keystr);
    key_gdbm.dsize = strlen(key_gdbm.dptr);

    ret = gdbm_exists(dbf, key_gdbm);
    Parrot_str_free_cstring(key_gdbm.dptr);

    return ret;
#line 178 "./gdbmhash.c"
}
static  INTVAL 
Parrot_GDBMHash_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 179 "./gdbmhash.pmc"

    GDBM_FILE dbf = PMC_dbfh(pmc);
    if (! dbf) {
        return 0;
    }
    else {
        datum key = gdbm_firstkey(dbf);
        if (key.dptr) {
            return 1;
        }
        else {
            return 0;
        }
    }
#line 198 "./gdbmhash.c"
}
static  INTVAL 
Parrot_GDBMHash_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 151 "./gdbmhash.pmc"

    GDBM_FILE dbf = PMC_dbfh(pmc);
    if (! dbf) {
        return 0;
    }
    else {
        INTVAL cnt = 0;
        datum key, nextkey;
        for (key = gdbm_firstkey(dbf); key.dptr; key = nextkey) {
            cnt++;
            nextkey = gdbm_nextkey(dbf, key);
            free(key.dptr);
        }

        return cnt;
    }
#line 220 "./gdbmhash.c"
}
static  PMC* 
Parrot_GDBMHash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 286 "./gdbmhash.pmc"

    STRING * const ret_string = VTABLE_get_string_keyed(interp, pmc, key);
    PMC    * const ret_pmc    = Parrot_pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, ret_pmc, ret_string);

    return ret_pmc;
#line 233 "./gdbmhash.c"
}
static  void* 
Parrot_GDBMHash_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 113 "./gdbmhash.pmc"

    return PMC_dbfh(pmc);
#line 241 "./gdbmhash.c"
}
static  STRING* 
Parrot_GDBMHash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 235 "./gdbmhash.pmc"

    STRING *keystr, *val;
    GDBM_FILE dbf = PMC_dbfh(pmc);
    datum key_gdbm, val_gdbm;

    if (!key)
        return string_from_literal(interp, "");

    if (!dbf)
        return string_from_literal(interp, "");

    keystr         = make_hash_key(interp, key);

    key_gdbm.dptr  = Parrot_str_to_cstring(interp, keystr);
    key_gdbm.dsize = strlen(key_gdbm.dptr);
    val_gdbm       = gdbm_fetch(dbf, key_gdbm);

    val = Parrot_str_new(interp, val_gdbm.dptr, val_gdbm.dsize);
    Parrot_str_free_cstring(key_gdbm.dptr);
    free(val_gdbm.dptr);

    return val;
#line 269 "./gdbmhash.c"
}
static  void 
Parrot_GDBMHash_init(PARROT_INTERP, PMC *pmc)
{
#line 101 "./gdbmhash.pmc"

    Parrot_GDBMHash_attributes *attrs = PARROT_GDBMHASH(pmc);
    attrs->db_handle = mem_gc_allocate_zeroed_typed(interp, GDBM_FH);
    PObj_custom_destroy_SET(pmc);
#line 279 "./gdbmhash.c"
}
static  void 
Parrot_GDBMHash_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 305 "./gdbmhash.pmc"

    PMC * const temp = Parrot_pmc_new(interp, enum_class_String);

    VTABLE_set_integer_native(interp, temp, value);
    VTABLE_set_pmc_keyed(interp, pmc, key, temp);
#line 290 "./gdbmhash.c"
}
static  void 
Parrot_GDBMHash_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 323 "./gdbmhash.pmc"

    PMC * const temp = Parrot_pmc_new(interp, enum_class_String);

    VTABLE_set_number_native(interp, temp, value);
    VTABLE_set_pmc_keyed(interp, pmc, key, temp);
#line 301 "./gdbmhash.c"
}
static  void 
Parrot_GDBMHash_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 270 "./gdbmhash.pmc"

    STRING * const temp = VTABLE_get_string(interp, value);

    VTABLE_set_string_keyed(interp, pmc, key, temp);
#line 311 "./gdbmhash.c"
}
static  void 
Parrot_GDBMHash_set_pointer(PARROT_INTERP, PMC *pmc, void *p)
{
#line 117 "./gdbmhash.pmc"

    PMC_dbfh(pmc) = (GDBM_FILE)p;
#line 319 "./gdbmhash.c"
}
static  void 
Parrot_GDBMHash_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 203 "./gdbmhash.pmc"

    STRING* keystr;
    GDBM_FILE dbf = PMC_dbfh(pmc);
    datum key_gdbm, val_gdbm;

    if (!key) return;
    if (!dbf) return;
    keystr = make_hash_key(interp, key);

    key_gdbm.dptr  = Parrot_str_to_cstring(interp, keystr);
    key_gdbm.dsize = strlen(key_gdbm.dptr);
    val_gdbm.dptr  = Parrot_str_to_cstring(interp, value);
    val_gdbm.dsize = strlen(val_gdbm.dptr);

    gdbm_store(dbf, key_gdbm, val_gdbm, GDBM_REPLACE);

    Parrot_str_free_cstring(key_gdbm.dptr);
    Parrot_str_free_cstring(val_gdbm.dptr);

    return;
#line 345 "./gdbmhash.c"
}
static  void 
Parrot_GDBMHash_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 131 "./gdbmhash.pmc"

    char * const c_db_name = Parrot_str_to_cstring(interp, value);
    GDBM_FILE dbf          = gdbm_open(c_db_name, 0, GDBM_NEWDB, 0666, 0);

    Parrot_str_free_cstring(c_db_name);

    PMC_dbfh(pmc) = dbf;
#line 358 "./gdbmhash.c"
}
static  void
Parrot_GDBMHash_nci_open(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 370 "./gdbmhash.pmc"
PMC* pmc;
STRING* value;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &value);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 406 "./gdbmhash.pmc"

    VTABLE_set_string_native(interp, pmc, value);
#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 387 "./gdbmhash.c"
}
static  void
Parrot_GDBMHash_nci_close(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 399 "./gdbmhash.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 420 "./gdbmhash.pmc"

    gdbm_close(PMC_dbfh(pmc));
#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 415 "./gdbmhash.c"
}
#include "pmc/pmc_default.h"

PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_GDBMHash_update_vtable(VTABLE *vt) {
    vt->delete_keyed = Parrot_GDBMHash_delete_keyed;
    vt->destroy = Parrot_GDBMHash_destroy;
    vt->exists_keyed = Parrot_GDBMHash_exists_keyed;
    vt->get_bool = Parrot_GDBMHash_get_bool;
    vt->get_integer = Parrot_GDBMHash_get_integer;
    vt->get_pmc_keyed = Parrot_GDBMHash_get_pmc_keyed;
    vt->get_pointer = Parrot_GDBMHash_get_pointer;
    vt->get_string_keyed = Parrot_GDBMHash_get_string_keyed;
    vt->init = Parrot_GDBMHash_init;
    vt->set_integer_keyed = Parrot_GDBMHash_set_integer_keyed;
    vt->set_number_keyed = Parrot_GDBMHash_set_number_keyed;
    vt->set_pmc_keyed = Parrot_GDBMHash_set_pmc_keyed;
    vt->set_pointer = Parrot_GDBMHash_set_pointer;
    vt->set_string_keyed = Parrot_GDBMHash_set_string_keyed;
    vt->set_string_native = Parrot_GDBMHash_set_string_native;
    vt->attr_size = sizeof(Parrot_GDBMHash_attributes);

    return vt;
}


PARROT_DYNEXT_EXPORT 
VTABLE *Parrot_GDBMHash_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->destroy = Parrot_GDBMHash_destroy;
    vt->exists_keyed = Parrot_GDBMHash_exists_keyed;
    vt->get_bool = Parrot_GDBMHash_get_bool;
    vt->get_integer = Parrot_GDBMHash_get_integer;
    vt->get_pmc_keyed = Parrot_GDBMHash_get_pmc_keyed;
    vt->get_pointer = Parrot_GDBMHash_get_pointer;
    vt->get_string_keyed = Parrot_GDBMHash_get_string_keyed;
    vt->init = Parrot_GDBMHash_init;
    vt->attr_size = sizeof(Parrot_GDBMHash_attributes);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_GDBMHash_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_GDBMHash_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_GDBMHash_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_GDBMHash_ro_update_vtable(vt);

    return vt;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_GDBMHash_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "GDBMHash", 8, NULL, 0));
    return mro;
}

PARROT_DYNEXT_EXPORT 
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_GDBMHash_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "GDBMHash")), PMCNULL);
    return isa;
}

static void thispmc_class_init(PARROT_INTERP, int entry)
{
    
    #ifdef WIN32
        /* TT #1252:  What if libgdbm.so cannot be loaded */
        /* Parrot_load_lib(interp, slib, NULL); */
        STRING *slib = CONST_STRING(interp, "gdbm3");
    #endif

}
void
Parrot_GDBMHash_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":db_handle ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_GDBMHash_get_vtable(interp);
        vt->base_type      = -1;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->base_type    = entry;
        vt->whoami       = string_make(interp, "GDBMHash", 8,
                                       "ascii", PObj_constant_FLAG|PObj_external_FLAG);
        vt->provides_str = Parrot_str_append(interp, vt->provides_str,
            string_make(interp, "hash", 4, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG));

        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_GDBMHash_ro_get_vtable(interp);
            vt_ro->base_type      = -1;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_GDBMHash_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_GDBMHash_nci_open), CONST_STRING_GEN(interp, "open"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_GDBMHash_nci_close), CONST_STRING_GEN(interp, "close"));

        /* class_init */
        thispmc_class_init(interp, entry);


        {
        }
    } /* pass */
} /* Parrot_GDBMHash_class_init */
/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */


PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_gdbmhash_load(PARROT_INTERP); /* don't warn */
PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_gdbmhash_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    Parrot_Int typeGDBMHash;
    int pass;

    /* create a library PMC */
    pmc = Parrot_pmc_new_constant(interp, enum_class_ParrotLibrary);

    /* TODO: stuff some info into this PMC's props */

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "GDBMHash");
    typeGDBMHash = Parrot_pmc_register_new_type(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_GDBMHash_class_init(interp, typeGDBMHash, pass);
    }
    return pmc;
}

#line 422 "./gdbmhash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>, L<http://gdbm.gnu.org>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
