/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/arrayiterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_arrayiterator.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "arrayiterator.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/arrayiterator.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: arrayiterator.pmc 45297 2010-03-30 01:33:45Z coke $

=head1 NAME

src/pmc/arrayiterator.pmc - Implementation of Iterator for Arrays.

=head1 DESCRIPTION

Generic iterator for traversing arrays.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, array, entry
    iterator = iter array
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = shift iterator     # get an entry
    ...
    goto iter_loop
  iter_end:


=head2 iterate from the end, for arrays

    .local pmc iterator, array, entry
    iterator = iter array
    iterator = .ITERATE_FROM_END
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = pop iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 Warning!

NB: for different direction you have to use different ops!

TODO: Discuss idea of having separate get_iter/get_reverse_iter VTABLEs
to avoid this caveat.

=head1 Methods

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 80 "./src/pmc/arrayiterator.c"
static  PMC*  Parrot_ArrayIterator_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_ArrayIterator_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  INTVAL  Parrot_ArrayIterator_elements(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_ArrayIterator_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  INTVAL  Parrot_ArrayIterator_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_get_integer(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  INTVAL  Parrot_ArrayIterator_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  FLOATVAL  Parrot_ArrayIterator_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  FLOATVAL  Parrot_ArrayIterator_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  PMC  * Parrot_ArrayIterator_get_pmc(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_ArrayIterator_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  PMC  * Parrot_ArrayIterator_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  STRING  * Parrot_ArrayIterator_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key);
static  STRING  * Parrot_ArrayIterator_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx);
static  void  Parrot_ArrayIterator_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ArrayIterator_init_pmc(PARROT_INTERP, PMC *pmc, PMC *array);
static  void  Parrot_ArrayIterator_mark(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_ArrayIterator_pop_float(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_pop_integer(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_ArrayIterator_pop_pmc(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_ArrayIterator_pop_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ArrayIterator_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  FLOATVAL  Parrot_ArrayIterator_shift_float(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_ArrayIterator_shift_integer(PARROT_INTERP, PMC *pmc);
static  PMC  * Parrot_ArrayIterator_shift_pmc(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_ArrayIterator_shift_string(PARROT_INTERP, PMC *pmc);
void    Parrot_ArrayIterator_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ArrayIterator_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ArrayIterator_get_vtable(PARROT_INTERP);
void    Parrot_ArrayIterator_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ArrayIterator_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ArrayIterator_ro_get_vtable(PARROT_INTERP);
static  PMC* 
Parrot_ArrayIterator_clone(PARROT_INTERP, PMC *pmc)
{
#line 126 "./src/pmc/arrayiterator.pmc"

    INTVAL pos, reverse;
    PMC   *array;
    PMC   *clone;

    GETATTR_ArrayIterator_array(interp, pmc, array);
    GETATTR_ArrayIterator_pos(interp, pmc, pos);
    GETATTR_ArrayIterator_reverse(interp, pmc, reverse);

    clone = Parrot_pmc_new_init(interp, enum_class_ArrayIterator, array);

    SETATTR_ArrayIterator_pos(interp, clone, pos);
    SETATTR_ArrayIterator_reverse(interp, clone, reverse);

    return clone;
#line 135 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 620 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_defined_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 143 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 634 "./src/pmc/arrayiterator.pmc"

    INTVAL pos, reverse, final_pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);
    GETATTR_ArrayIterator_reverse(interp, pmc, reverse);
    GETATTR_ArrayIterator_array(interp, pmc, array);

    /* Cheat! */
    final_pos = pos + idx - reverse;

    return VTABLE_defined_keyed_int(interp, array, final_pos);
#line 161 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_elements(PARROT_INTERP, PMC *pmc)
{
#line 167 "./src/pmc/arrayiterator.pmc"

    INTVAL reverse, pos, length;

    GETATTR_ArrayIterator_reverse(interp, pmc, reverse);

    if (reverse) {
        GETATTR_ArrayIterator_pos(interp, pmc, pos);
        return pos;
    }
    else {
        GETATTR_ArrayIterator_length(interp, pmc, length);
        GETATTR_ArrayIterator_pos(interp, pmc, pos);
        return length - pos;
    }
#line 181 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 584 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_exists_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 189 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 598 "./src/pmc/arrayiterator.pmc"

    INTVAL pos, reverse, final_pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);
    GETATTR_ArrayIterator_reverse(interp, pmc, reverse);
    GETATTR_ArrayIterator_array(interp, pmc, array);

    /* Cheat! */
    final_pos = pos + idx - reverse;

    return VTABLE_exists_keyed_int(interp, array, final_pos);
#line 207 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 153 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_elements(interp, pmc) > 0;
#line 215 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 183 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_elements(interp, pmc);
#line 223 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 487 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_integer_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 231 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 501 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);

    return VTABLE_get_integer_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, pmc),
            pos + idx);
#line 244 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 518 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_number_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 252 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 532 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);

    return VTABLE_get_number_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, pmc),
            pos + idx);
#line 265 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 232 "./src/pmc/arrayiterator.pmc"

    PMC *array;
    GETATTR_ArrayIterator_array(interp, pmc, array);
    return array ? array : PMCNULL;
#line 275 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 457 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_pmc_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 283 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 471 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);

    return VTABLE_get_pmc_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, pmc),
            pos + idx);
#line 296 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 551 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_string_keyed_int(interp, pmc, VTABLE_get_integer(interp, key));
#line 304 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 565 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);

    return VTABLE_get_string_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, pmc),
            pos + idx);
#line 317 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_init(PARROT_INTERP, PMC *pmc)
{
#line 75 "./src/pmc/arrayiterator.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "ArrayIterator init without aggregate");
#line 326 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_init_pmc(PARROT_INTERP, PMC *pmc, PMC *array)
{
#line 91 "./src/pmc/arrayiterator.pmc"


    SETATTR_ArrayIterator_array(interp, pmc, array);

    PObj_custom_mark_SET(pmc);

    /* by default, iterate from start */
    Parrot_ArrayIterator_set_integer_native(interp, pmc, ITERATE_FROM_START);
#line 340 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_mark(PARROT_INTERP, PMC *pmc)
{
#line 111 "./src/pmc/arrayiterator.pmc"

    PMC *array;

    GETATTR_ArrayIterator_array(interp, pmc, array);

    Parrot_gc_mark_PMC_alive(interp, array);
#line 352 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 380 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    GETATTR_ArrayIterator_array(interp, pmc, array);
    SETATTR_ArrayIterator_pos(interp, pmc, --pos);

    return VTABLE_get_number_keyed_int(interp, array, pos);
#line 372 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 355 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);


    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    GETATTR_ArrayIterator_array(interp, pmc, array);
    SETATTR_ArrayIterator_pos(interp, pmc, --pos);

    return VTABLE_get_integer_keyed_int(interp, array, pos);
#line 393 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 432 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    GETATTR_ArrayIterator_array(interp, pmc, array);
    SETATTR_ArrayIterator_pos(interp, pmc, --pos);

    return VTABLE_get_pmc_keyed_int(interp, array, pos);
#line 413 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 405 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    GETATTR_ArrayIterator_array(interp, pmc, array);
    SETATTR_ArrayIterator_pos(interp, pmc, --pos);

    return VTABLE_get_string_keyed_int(interp, array, pos);
#line 433 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 200 "./src/pmc/arrayiterator.pmc"

    PMC *array;

    if (value == ITERATE_FROM_START) {
        GETATTR_ArrayIterator_array(interp, pmc, array);
        SETATTR_ArrayIterator_reverse(interp, pmc, 0);
        SETATTR_ArrayIterator_pos(interp, pmc, 0);
        SETATTR_ArrayIterator_length(interp, pmc, VTABLE_elements(interp, array));
    }
    else if (value == ITERATE_FROM_END) {
        INTVAL element;
        GETATTR_ArrayIterator_array(interp, pmc, array);
        element = VTABLE_elements(interp, array);
        SETATTR_ArrayIterator_reverse(interp, pmc, 1);
        SETATTR_ArrayIterator_length(interp, pmc, element);
        SETATTR_ArrayIterator_pos(interp, pmc, element);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Wrong direction for ArrayIterator");
#line 459 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 274 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    GETATTR_ArrayIterator_array(interp, pmc, array);
    SETATTR_ArrayIterator_pos(interp, pmc, pos+1);

    return VTABLE_get_number_keyed_int(interp, array, pos);
#line 479 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 249 "./src/pmc/arrayiterator.pmc"

    INTVAL pos, length;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);
    GETATTR_ArrayIterator_length(interp, pmc, length);

    if (pos >= length)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    GETATTR_ArrayIterator_array(interp, pmc, array);
    SETATTR_ArrayIterator_pos(interp, pmc, pos+1);

    return VTABLE_get_integer_keyed_int(interp, array, pos);
#line 500 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 326 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);


    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    GETATTR_ArrayIterator_array(interp, pmc, array);
    SETATTR_ArrayIterator_pos(interp, pmc, pos+1);

    return VTABLE_get_pmc_keyed_int(interp, array, pos);
#line 521 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 299 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, pmc, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    GETATTR_ArrayIterator_array(interp, pmc, array);
    SETATTR_ArrayIterator_pos(interp, pmc, pos+1);

    return VTABLE_get_string_keyed_int(interp, array, pos);
#line 541 "./src/pmc/arrayiterator.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ArrayIterator_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ArrayIterator_clone;
    vt->defined_keyed = Parrot_ArrayIterator_defined_keyed;
    vt->defined_keyed_int = Parrot_ArrayIterator_defined_keyed_int;
    vt->elements = Parrot_ArrayIterator_elements;
    vt->exists_keyed = Parrot_ArrayIterator_exists_keyed;
    vt->exists_keyed_int = Parrot_ArrayIterator_exists_keyed_int;
    vt->get_bool = Parrot_ArrayIterator_get_bool;
    vt->get_integer = Parrot_ArrayIterator_get_integer;
    vt->get_integer_keyed = Parrot_ArrayIterator_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_ArrayIterator_get_integer_keyed_int;
    vt->get_number_keyed = Parrot_ArrayIterator_get_number_keyed;
    vt->get_number_keyed_int = Parrot_ArrayIterator_get_number_keyed_int;
    vt->get_pmc = Parrot_ArrayIterator_get_pmc;
    vt->get_pmc_keyed = Parrot_ArrayIterator_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ArrayIterator_get_pmc_keyed_int;
    vt->get_string_keyed = Parrot_ArrayIterator_get_string_keyed;
    vt->get_string_keyed_int = Parrot_ArrayIterator_get_string_keyed_int;
    vt->init = Parrot_ArrayIterator_init;
    vt->init_pmc = Parrot_ArrayIterator_init_pmc;
    vt->mark = Parrot_ArrayIterator_mark;
    vt->pop_float = Parrot_ArrayIterator_pop_float;
    vt->pop_integer = Parrot_ArrayIterator_pop_integer;
    vt->pop_pmc = Parrot_ArrayIterator_pop_pmc;
    vt->pop_string = Parrot_ArrayIterator_pop_string;
    vt->set_integer_native = Parrot_ArrayIterator_set_integer_native;
    vt->shift_float = Parrot_ArrayIterator_shift_float;
    vt->shift_integer = Parrot_ArrayIterator_shift_integer;
    vt->shift_pmc = Parrot_ArrayIterator_shift_pmc;
    vt->shift_string = Parrot_ArrayIterator_shift_string;
    vt->attr_size = sizeof(Parrot_ArrayIterator_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ArrayIterator_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ArrayIterator_clone;
    vt->defined_keyed = Parrot_ArrayIterator_defined_keyed;
    vt->defined_keyed_int = Parrot_ArrayIterator_defined_keyed_int;
    vt->elements = Parrot_ArrayIterator_elements;
    vt->exists_keyed = Parrot_ArrayIterator_exists_keyed;
    vt->exists_keyed_int = Parrot_ArrayIterator_exists_keyed_int;
    vt->get_bool = Parrot_ArrayIterator_get_bool;
    vt->get_integer = Parrot_ArrayIterator_get_integer;
    vt->get_integer_keyed = Parrot_ArrayIterator_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_ArrayIterator_get_integer_keyed_int;
    vt->get_number_keyed = Parrot_ArrayIterator_get_number_keyed;
    vt->get_number_keyed_int = Parrot_ArrayIterator_get_number_keyed_int;
    vt->get_pmc = Parrot_ArrayIterator_get_pmc;
    vt->get_pmc_keyed = Parrot_ArrayIterator_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ArrayIterator_get_pmc_keyed_int;
    vt->get_string_keyed = Parrot_ArrayIterator_get_string_keyed;
    vt->get_string_keyed_int = Parrot_ArrayIterator_get_string_keyed_int;
    vt->init = Parrot_ArrayIterator_init;
    vt->init_pmc = Parrot_ArrayIterator_init_pmc;
    vt->mark = Parrot_ArrayIterator_mark;
    vt->attr_size = sizeof(Parrot_ArrayIterator_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ArrayIterator_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_get_vtable(interp);
    Parrot_ArrayIterator_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ArrayIterator_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_ro_get_vtable(interp);
    Parrot_ArrayIterator_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ArrayIterator_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Iterator_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "ArrayIterator", 13, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ArrayIterator_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Iterator_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ArrayIterator")), PMCNULL);
    return isa;
}

void
Parrot_ArrayIterator_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Farray Ipos Ilength Ireverse ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ArrayIterator_get_vtable(interp);
        vt->base_type      = enum_class_ArrayIterator;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ArrayIterator");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_ArrayIterator_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ArrayIterator_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ArrayIterator;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ArrayIterator_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ArrayIterator_class_init */
#line 646 "./src/pmc/arrayiterator.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
