/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/codestring.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_codestring.h"
#include "pmc_string.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "codestring.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/codestring.pmc"
/*
Copyright (C) 2007-2009, Parrot Foundation.
$Id: codestring.pmc 45425 2010-04-07 13:38:10Z bacek $

=head1 NAME

src/pmc/codestring.pmc - CodeString PMC Class

=head1 DESCRIPTION

C<CodeString> is a class intended to simplify the process of emitting code
strings.  Ideally this will eventually become a form of "CodeBuffer" that is
more efficient than string concatenation, but for now it works well enough for
me.

The primary method for C<CodeString> objects is C<emit>, which appends a line
(or lines) of code to the string according to a format parameter.  The line can
contain substitution markers (ala printf) that indicate where other parameters
to the call should be placed.

Note that C<CodeString> is just a subclass of Parrot's native C<String> class,
so it's easy to combine CodeString objects with other strings outside of the
C<emit> method.

=head2 Methods

=over 4

=cut

*/

#if PARROT_HAS_ICU
#  include <unicode/uchar.h>
#endif

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 65 "./src/pmc/codestring.c"
static  void  Parrot_CodeString_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_CodeString_mark(PARROT_INTERP, PMC *pmc);
static  void Parrot_CodeString_nci_emit(PARROT_INTERP, PMC *pmc);
static  void Parrot_CodeString_nci_lineof(PARROT_INTERP, PMC *pmc);
static  void Parrot_CodeString_nci_unique(PARROT_INTERP, PMC *pmc);
static  void Parrot_CodeString_nci_escape(PARROT_INTERP, PMC *pmc);
static  void Parrot_CodeString_nci_charname_to_ord(PARROT_INTERP, PMC *pmc);
static  void Parrot_CodeString_nci_key(PARROT_INTERP, PMC *pmc);
void    Parrot_CodeString_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_CodeString_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_CodeString_get_vtable(PARROT_INTERP);
void    Parrot_CodeString_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_CodeString_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_CodeString_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_CodeString_init(PARROT_INTERP, PMC *pmc)
{
#line 54 "./src/pmc/codestring.pmc"

    interp->vtables[enum_class_String]->init(interp, pmc);
    SETATTR_CodeString_linepos(interp, pmc, PMCNULL);
    PObj_custom_mark_SET(pmc);
#line 88 "./src/pmc/codestring.c"
}
static  void 
Parrot_CodeString_mark(PARROT_INTERP, PMC *pmc)
{
#line 70 "./src/pmc/codestring.pmc"

    interp->vtables[enum_class_String]->mark(interp, pmc);
    if (PMC_data(pmc)) {
        PMC *linepos;

        GETATTR_CodeString_linepos(interp, pmc, linepos);

        Parrot_gc_mark_PMC_alive(interp, linepos);
    }
#line 103 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_emit(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 115 "./src/pmc/codestring.pmc"
PMC* pmc;
STRING* fmt;
PMC* args;
PMC* hash;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSPsPns",
            &pmc, &fmt, &args, &hash);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 106 "./src/pmc/codestring.pmc"

STRING * const percent     = CONST_STRING(interp, "%");
STRING * const comma       = CONST_STRING(interp, ",");
STRING * const comma_space = CONST_STRING(interp, ", ");
STRING * const newline     = CONST_STRING(interp, "\n");
STRING *key, *repl, *S1;
INTVAL pos          = 0;
INTVAL replen       = 0;

fmt = Parrot_str_new_COW(interp, fmt);

while (pos >= 0) {
    pos += replen;
    pos = Parrot_str_find_index(interp, fmt, percent, pos);
    if (pos < 0)
        break;

    key = Parrot_str_substr(interp, fmt, pos+1, 1, &key, 0);

    if (VTABLE_exists_keyed_str(interp, hash, key)) {
        repl = VTABLE_get_string_keyed_str(interp, hash, key);
    }
    else if (Parrot_str_is_cclass(interp, enum_cclass_numeric, fmt, (UINTVAL)pos + 1)) {
        const INTVAL I0 = Parrot_str_to_int(interp, key);
        repl = VTABLE_get_string_keyed_int(interp, args, I0);
    }
    else if (Parrot_str_equal(interp, key, comma)) {
        INTVAL I0;
        INTVAL I1;

        repl = VTABLE_get_string_keyed_int(interp, args, 0);
        repl = Parrot_str_new_COW(interp, repl);
        I1   = VTABLE_elements(interp, args);
        I0   = 1;

        while (I0 < I1) {
            STRING * const S0 = VTABLE_get_string_keyed_int(interp, args, I0);
            repl = Parrot_str_append(interp, repl, comma_space);
            repl = Parrot_str_append(interp, repl, S0);
            I0++;
        }
    }
    else if (Parrot_str_equal(interp, key, percent)) {
        repl = percent;
    }
    else {
        /* No substitution is necessary */
        replen = 2;
        continue;
    }

    (void) Parrot_str_replace(interp, fmt, pos, 2, repl, NULL);
    replen = Parrot_str_byte_length(interp, repl);
}

/* Add a newline if necessary */
if ('\n' != Parrot_str_indexed(interp, fmt, Parrot_str_byte_length(interp, fmt) - 1))
    fmt = Parrot_str_concat(interp, fmt, newline, 0);

GETATTR_CodeString_str_val(interp, pmc, S1);
S1 = Parrot_str_concat(interp, S1, fmt, 0);
VTABLE_set_string_native(interp, pmc, S1);

#line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *pmc */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)pmc);
    return;
    /*END RETURN PMC *pmc */
    }
#line 169 "./src/pmc/codestring.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 206 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_lineof(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 218 "./src/pmc/codestring.pmc"
PMC* pmc;
INTVAL pos;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &pmc, &pos);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 184 "./src/pmc/codestring.pmc"

PMC    *linepos;
INTVAL  count;
INTVAL  line = 0;

GETATTR_CodeString_linepos(interp, pmc, linepos);

/* build the linepos array if we haven't already done so */
if (!linepos || PMC_IS_NULL(linepos)) {
    STRING *str             = NULL;
    INTVAL  eos;
    INTVAL  jpos;

    linepos = Parrot_pmc_new(interp, enum_class_ResizableIntegerArray);
    /* get the string itself */
    GETATTR_CodeString_str_val(interp, pmc, str);
    eos  = Parrot_str_byte_length(interp, str);
    /* find the first newline, if any */
    jpos = Parrot_str_find_cclass(interp, enum_cclass_newline,
                                  str, 0, eos);
    while (jpos < eos) {
        jpos++;
        /* add the start of line position */
        VTABLE_push_integer(interp, linepos, jpos);

        /* treat \r\n as a single newline */
        if (jpos < eos
        && string_ord(interp, str, jpos - 1)     == 13
        && string_ord(interp, str, jpos)         == 10) {
            jpos++;
        }
        /* search for the next newline */
        jpos = Parrot_str_find_cclass(interp, enum_cclass_newline,
                                      str, jpos, eos);
    }
    /* save the array of line positions */
    SETATTR_CodeString_linepos(interp, pmc, linepos);
}

/* Find the line from the array, stop at the first index that is
 * greater than the position we're looking for.  We do a linear
 * search for now, * perhaps a binary search would be better someday.
 */
count = VTABLE_elements(interp, linepos);
while (line < count
      && VTABLE_get_integer_keyed_int(interp, linepos, line) <= pos)
    line++;

#line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL line */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)line);
    return;
    /*END RETURN INTVAL line */
    }
#line 232 "./src/pmc/codestring.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 292 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_unique(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 304 "./src/pmc/codestring.pmc"
PMC* pmc;
STRING* format;
INTVAL has_fmt;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &pmc, &format, &has_fmt);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 250 "./src/pmc/codestring.pmc"

static INTVAL counter = 10;
STRING * const counter_as_string = Parrot_str_from_int(interp, counter);
UNUSED(pmc);

counter++;

if (!has_fmt) {
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *counter_as_string */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)counter_as_string);
    return;
    /*END RETURN STRING *counter_as_string */
    }
#line 258 "./src/pmc/codestring.pmc"

}
else {
    STRING *result = Parrot_str_copy(interp, format);
    result         = Parrot_str_concat(interp, result, counter_as_string, 1);
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)result);
    return;
    /*END RETURN STRING *result */
    }
#line 263 "./src/pmc/codestring.pmc"

}
#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 355 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_escape(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 367 "./src/pmc/codestring.pmc"
PMC* pmc;
STRING* str;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &str);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 279 "./src/pmc/codestring.pmc"

STRING *escaped_str  = Parrot_str_escape(interp, str);
STRING * const quote = CONST_STRING(interp, "\x22");
STRING * const x     = CONST_STRING(interp, "\\x");
INTVAL x_pos;
INTVAL is_unicode = 0;
UNUSED(pmc);

escaped_str = Parrot_str_concat(interp, quote, escaped_str, 1);
escaped_str = Parrot_str_concat(interp, escaped_str, quote, 1);
x_pos       = Parrot_str_find_index(interp, escaped_str, x, 0);

if (x_pos != -1) {
    is_unicode = 1;
}
else {
    STRING * const u = CONST_STRING(interp, "\\u");
    const INTVAL u_pos = Parrot_str_find_index(interp, escaped_str, u, 0);
    if (u_pos != -1)
        is_unicode = 1;
}

if (is_unicode) {
    STRING * const unicode = CONST_STRING(interp, "unicode:");
    escaped_str            = Parrot_str_concat(interp, unicode, escaped_str, 1);
}

#line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *escaped_str */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)escaped_str);
    return;
    /*END RETURN STRING *escaped_str */
    }
#line 306 "./src/pmc/codestring.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 420 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_charname_to_ord(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 432 "./src/pmc/codestring.pmc"
PMC* pmc;
STRING* name;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &name);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 321 "./src/pmc/codestring.pmc"

#if PARROT_HAS_ICU
UErrorCode   err       = U_ZERO_ERROR;
char * const cstr      = Parrot_str_to_cstring(interp, name);
UChar32      codepoint = u_charFromName(U_EXTENDED_CHAR_NAME, cstr, &err);
Parrot_str_free_cstring(cstr);
if (U_SUCCESS(err)) {
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL codepoint */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)codepoint);
    return;
    /*END RETURN INTVAL codepoint */
    }
#line 328 "./src/pmc/codestring.pmc"

}
#line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL -1 */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)-1);
    return;
    /*END RETURN INTVAL -1 */
    }
#line 330 "./src/pmc/codestring.pmc"

#else
Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
    "no ICU lib loaded");
#endif
#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 481 "./src/pmc/codestring.c"
}
static  void
Parrot_CodeString_nci_key(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 493 "./src/pmc/codestring.pmc"
PMC* pmc;
PMC* args;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPs",
            &pmc, &args);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 348 "./src/pmc/codestring.pmc"

INTVAL         index;
const INTVAL   elements      = VTABLE_elements(interp, args);
STRING * const open_bracket  = CONST_STRING(interp, "[");
STRING * const semi          = CONST_STRING(interp, ";");
STRING * const close_bracket = CONST_STRING(interp, "]");
STRING * const s_array       = CONST_STRING(interp, "array");
STRING *       prefix        = NULL;
STRING *       out           = open_bracket;

for (index = 0; index < elements; index++) {
    PMC * const P0 = VTABLE_get_pmc_keyed_int(interp, args, index);

    if (!PMC_IS_NULL(P0)) {
        if (VTABLE_does(interp, P0, s_array)) {
            const INTVAL elements2 = VTABLE_elements(interp, P0);
            INTVAL index2;

            for (index2 = 0; index2 < elements2; index2++) {
                STRING *S0   = VTABLE_get_string_keyed_int(interp, P0, index2);
                #line 523 "./src/pmc/codestring.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, pmc, CONST_STRING_GEN(interp, "escape"), "S->S", S0, &S0);
#line 368 "./src/pmc/codestring.pmc"

                if (prefix)
                    out = Parrot_str_append(interp, out, prefix);
                out    = Parrot_str_append(interp, out, S0);
                prefix = semi;
            }
        }
        else {
            STRING *S0   = VTABLE_get_string_keyed_int(interp, args, index);
            #line 535 "./src/pmc/codestring.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, pmc, CONST_STRING_GEN(interp, "escape"), "S->S", S0, &S0);
#line 377 "./src/pmc/codestring.pmc"

            if (prefix)
                out = Parrot_str_append(interp, out, prefix);
            out    = Parrot_str_append(interp, out, S0);
            prefix = semi;
        }
    }
}

out = Parrot_str_append(interp, out, close_bracket);

#line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *out */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)out);
    return;
    /*END RETURN STRING *out */
    }
#line 388 "./src/pmc/codestring.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 565 "./src/pmc/codestring.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_CodeString_update_vtable(VTABLE *vt) {
    vt->init = Parrot_CodeString_init;
    vt->mark = Parrot_CodeString_mark;
    vt->attr_size = sizeof(Parrot_CodeString_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_CodeString_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->init = Parrot_CodeString_init;
    vt->mark = Parrot_CodeString_mark;
    vt->attr_size = sizeof(Parrot_CodeString_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_CodeString_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_String_get_vtable(interp);
    Parrot_CodeString_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_CodeString_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_String_ro_get_vtable(interp);
    Parrot_CodeString_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_CodeString_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_String_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "CodeString", 10, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_CodeString_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_String_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "CodeString")), PMCNULL);
    return isa;
}

void
Parrot_CodeString_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Sstr_val Flinepos ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_CodeString_get_vtable(interp);
        vt->base_type      = enum_class_CodeString;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "CodeString");
        vt->provides_str = CONST_STRING_GEN(interp, "string");
        vt->isa_hash     = Parrot_CodeString_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_CodeString_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_CodeString;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_CodeString_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_CodeString_nci_emit), CONST_STRING_GEN(interp, "emit"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_CodeString_nci_lineof), CONST_STRING_GEN(interp, "lineof"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_CodeString_nci_unique), CONST_STRING_GEN(interp, "unique"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_CodeString_nci_escape), CONST_STRING_GEN(interp, "escape"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_CodeString_nci_charname_to_ord), CONST_STRING_GEN(interp, "charname_to_ord"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_CodeString_nci_key), CONST_STRING_GEN(interp, "key"));
        {
        }
    } /* pass */
} /* Parrot_CodeString_class_init */
#line 398 "./src/pmc/codestring.pmc"



/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
