/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/continuation.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_continuation.h"
#include "pmc_default.h"
#include "continuation.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/continuation.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: continuation.pmc 45219 2010-03-28 01:11:50Z petdance $

=head1 NAME

src/pmc/continuation.pmc - Continuation PMC

=head1 DESCRIPTION

A C<Continuation> has a copy of the interpreter's context at the location where
the Continuation was constructed.  See the L<Glossary|docs/glossary.pod> for
more information.

=head2 Functions

=over 4

=cut

*/


#include "parrot/oplib/ops.h"
#include "pmc/pmc_sub.h"

/*

=back

=head2 Methods

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */


/*
 * A Continuation (and RetContinuation, ExceptionHandler) has in its
 * context a pointer to the register frame, which contains active objects.
 * Additionally ct->current_cont has the continuation of the caller.
 */
#line 72 "./src/pmc/continuation.c"
static  PMC  * Parrot_Continuation_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Continuation_defined(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Continuation_get_bool(PARROT_INTERP, PMC *pmc);
static  void  * Parrot_Continuation_get_pointer(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Continuation_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Continuation_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Continuation_init_pmc(PARROT_INTERP, PMC *pmc, PMC *values);
static  opcode_t  * Parrot_Continuation_invoke(PARROT_INTERP, PMC *pmc, void *next);
static  void  Parrot_Continuation_mark(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Continuation_set_pmc(PARROT_INTERP, PMC *pmc, PMC *src);
static  void  Parrot_Continuation_set_pointer(PARROT_INTERP, PMC *pmc, void *value);
static  void Parrot_Continuation_nci_caller(PARROT_INTERP, PMC *pmc);
static  void Parrot_Continuation_nci_continuation(PARROT_INTERP, PMC *pmc);
void    Parrot_Continuation_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Continuation_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Continuation_get_vtable(PARROT_INTERP);
void    Parrot_Continuation_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Continuation_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Continuation_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Continuation_clone(PARROT_INTERP, PMC *pmc)
{
#line 162 "./src/pmc/continuation.pmc"

    /* Start to prepare for subclassable continuations */
    return Parrot_pmc_new_init(interp, pmc->vtable->base_type, pmc);
#line 99 "./src/pmc/continuation.c"
}
static  INTVAL 
Parrot_Continuation_defined(PARROT_INTERP, PMC *pmc)
{
#line 226 "./src/pmc/continuation.pmc"

    opcode_t          *address;

    GETATTR_Continuation_address(interp, pmc, address);

    return address != NULL;
#line 111 "./src/pmc/continuation.c"
}
static  INTVAL 
Parrot_Continuation_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 234 "./src/pmc/continuation.pmc"

    opcode_t          *address;

    GETATTR_Continuation_address(interp, pmc, address);

    return address != NULL;
#line 123 "./src/pmc/continuation.c"
}
static  void  *
Parrot_Continuation_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 206 "./src/pmc/continuation.pmc"

    opcode_t          *address;

    GETATTR_Continuation_address(interp, pmc, address);

    return address;
#line 135 "./src/pmc/continuation.c"
}
static  STRING  *
Parrot_Continuation_get_string(PARROT_INTERP, PMC *pmc)
{
#line 289 "./src/pmc/continuation.pmc"

    PMC *to_ctx;

    GETATTR_Continuation_to_ctx(interp, pmc, to_ctx);

    return Parrot_Context_infostr(interp, to_ctx);
#line 147 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_init(PARROT_INTERP, PMC *pmc)
{
#line 70 "./src/pmc/continuation.pmc"

    PMC * const to_ctx = CURRENT_CONTEXT(interp);

    SETATTR_Continuation_to_ctx(interp, pmc, to_ctx);
    SETATTR_Continuation_to_call_object(interp, pmc, Parrot_pcc_get_signature(interp, to_ctx));
    SETATTR_Continuation_from_ctx(interp, pmc, CURRENT_CONTEXT(interp));
    SETATTR_Continuation_runloop_id(interp, pmc, 0);
    SETATTR_Continuation_seg(interp, pmc, interp->code);
    SETATTR_Continuation_address(interp, pmc, NULL);

    PObj_custom_mark_SET(pmc);

    /* PANIC("don't do that"); */
    /*
     * Whenever we create a continuation, all return continuations
     * up the call chain may be reused due to invoking the
     * continuation. To avoid that all return continuations are
     * converted to true continuations.
     */
    invalidate_retc_context(interp, pmc);
#line 173 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_init_pmc(PARROT_INTERP, PMC *pmc, PMC *values)
{
#line 93 "./src/pmc/continuation.pmc"

    PMC               *to_ctx;
    opcode_t          *address;
    PackFile_ByteCode *seg;

    GETATTR_Continuation_to_ctx(interp, values, to_ctx);
    SETATTR_Continuation_to_ctx(interp, pmc, to_ctx);
    SETATTR_Continuation_to_call_object(interp, pmc, Parrot_pcc_get_signature(interp, to_ctx));

    SETATTR_Continuation_from_ctx(interp, pmc, CURRENT_CONTEXT(interp));
    SETATTR_Continuation_runloop_id(interp, pmc, 0);

    GETATTR_Continuation_seg(interp, values, seg);
    SETATTR_Continuation_seg(interp, pmc, seg);

    GETATTR_Continuation_address(interp, values, address);
    SETATTR_Continuation_address(interp, pmc, address);

    PObj_custom_mark_SET(pmc);

    /* PANIC("don't do that"); */
    /*
     * Whenever we create a continuation, all return continuations
     * up the call chain may be reused due to invoking the
     * continuation. To avoid that all return continuations are
     * converted to true continuations.
     */
    invalidate_retc_context(interp, pmc);
#line 207 "./src/pmc/continuation.c"
}
static  opcode_t  *
Parrot_Continuation_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 253 "./src/pmc/continuation.pmc"

    PMC * const        from_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
    PMC               *to_ctx, *call_obj;
    opcode_t          *pc;
    PackFile_ByteCode *seg;
    UNUSED(next)

    GETATTR_Continuation_seg(interp, pmc, seg);
    GETATTR_Continuation_address(interp, pmc, pc);
    GETATTR_Continuation_to_ctx(interp, pmc, to_ctx);
    GETATTR_Continuation_to_call_object(interp, pmc, call_obj);

    Parrot_continuation_check(interp, pmc);
    Parrot_continuation_rewind_environment(interp, pmc);

    if (!PMC_IS_NULL(from_obj)) {
        Parrot_pcc_set_signature(interp, CURRENT_CONTEXT(interp), from_obj);
    }

    /* switch segment */
    if (interp->code != seg)
        Parrot_switch_to_cs(interp, seg, 1);

    return pc;
#line 237 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_mark(PARROT_INTERP, PMC *pmc)
{
#line 135 "./src/pmc/continuation.pmc"

    PMC *tmp;

    /* If Continuation wasn't fully constructed yet */
    if (!PMC_data(pmc))
        return;

    GETATTR_Continuation_to_ctx(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_Continuation_to_call_object(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);

    GETATTR_Continuation_from_ctx(interp, pmc, tmp);
    Parrot_gc_mark_PMC_alive(interp, tmp);
#line 258 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_set_pmc(PARROT_INTERP, PMC *pmc, PMC *src)
{
#line 176 "./src/pmc/continuation.pmc"

    STRUCT_COPY((Parrot_Continuation_attributes *)PMC_data(pmc),
            (Parrot_Continuation_attributes *)PMC_data(src));
#line 267 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 191 "./src/pmc/continuation.pmc"

    SETATTR_Continuation_address(interp, pmc, (opcode_t *)value);
    SETATTR_Continuation_runloop_id(interp, pmc, interp->current_runloop_id);
#line 276 "./src/pmc/continuation.c"
}
static  void
Parrot_Continuation_nci_caller(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 288 "./src/pmc/continuation.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 307 "./src/pmc/continuation.pmc"

    PMC *to_ctx, *caller;

    GETATTR_Continuation_to_ctx(interp, pmc, to_ctx);

    caller = Parrot_pcc_get_sub(interp, to_ctx);

    if (!caller)
        caller = PMCNULL;
    else {
        Parrot_Sub_attributes *sub;
        PMC_get_sub(interp, caller, sub);
        if (!sub->seg)
            caller = PMCNULL;
    }

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *caller */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)caller);
    return;
    /*END RETURN PMC *caller */
    }
#line 323 "./src/pmc/continuation.pmc"


#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 330 "./src/pmc/continuation.c"
}
static  void
Parrot_Continuation_nci_continuation(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 342 "./src/pmc/continuation.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 336 "./src/pmc/continuation.pmc"

    PMC *to_ctx, *cont;

    GETATTR_Continuation_to_ctx(interp, pmc, to_ctx);

    cont = Parrot_pcc_get_continuation(interp, to_ctx);

    if (cont)
        #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *cont */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)cont);
    return;
    /*END RETURN PMC *cont */
    }
#line 344 "./src/pmc/continuation.pmc"


    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)PMCNULL);
    return;
    /*END RETURN PMC *PMCNULL */
    }
#line 346 "./src/pmc/continuation.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 387 "./src/pmc/continuation.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Continuation_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Continuation_clone;
    vt->defined = Parrot_Continuation_defined;
    vt->get_bool = Parrot_Continuation_get_bool;
    vt->get_pointer = Parrot_Continuation_get_pointer;
    vt->get_string = Parrot_Continuation_get_string;
    vt->init = Parrot_Continuation_init;
    vt->init_pmc = Parrot_Continuation_init_pmc;
    vt->invoke = Parrot_Continuation_invoke;
    vt->mark = Parrot_Continuation_mark;
    vt->set_pmc = Parrot_Continuation_set_pmc;
    vt->set_pointer = Parrot_Continuation_set_pointer;
    vt->attr_size = sizeof(Parrot_Continuation_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Continuation_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Continuation_clone;
    vt->defined = Parrot_Continuation_defined;
    vt->get_bool = Parrot_Continuation_get_bool;
    vt->get_pointer = Parrot_Continuation_get_pointer;
    vt->get_string = Parrot_Continuation_get_string;
    vt->init = Parrot_Continuation_init;
    vt->init_pmc = Parrot_Continuation_init_pmc;
    vt->invoke = Parrot_Continuation_invoke;
    vt->mark = Parrot_Continuation_mark;
    vt->attr_size = sizeof(Parrot_Continuation_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Continuation_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Continuation_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Continuation_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Continuation_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Continuation_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Continuation", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Continuation_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Continuation")), PMCNULL);
    return isa;
}

void
Parrot_Continuation_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":seg :address Fto_ctx Fto_call_object Ffrom_ctx :runloop_id :invoked ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Continuation_get_vtable(interp);
        vt->base_type      = enum_class_Continuation;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Continuation");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = NULL;
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Continuation_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Continuation;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Continuation_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Continuation_nci_caller), CONST_STRING_GEN(interp, "caller"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Continuation_nci_continuation), CONST_STRING_GEN(interp, "continuation"));
        {
        }
    } /* pass */
} /* Parrot_Continuation_class_init */
#line 347 "./src/pmc/continuation.pmc"


/*

=back

=head1 HISTORY

Initial revision by sean 2002/08/04.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
