/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/integer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_integer.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "integer.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/integer.pmc"
/*
Copyright (C) 2003-2010, Parrot Foundation.
$Id: integer.pmc 45365 2010-04-01 03:54:54Z petdance $

=head1 NAME

src/pmc/integer.pmc - Integer PMC class

=head1 DESCRIPTION

C<Integer> provides an integer for languages that want a value-restricted
integer type without going to an I register.

=head2 Functions

=over 4

=cut

*/

#include "pmc/pmc_bigint.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void maybe_throw_overflow_error(PARROT_INTERP)
        __attribute__nonnull__(1);

PARROT_IGNORABLE_RESULT
PARROT_CANNOT_RETURN_NULL
static PMC* upgrade_self_to_bignum(PARROT_INTERP, ARGMOD(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        FUNC_MODIFIES(*self);

#define ASSERT_ARGS_maybe_throw_overflow_error __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_upgrade_self_to_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

static void
maybe_throw_overflow_error(PARROT_INTERP)
{
    ASSERT_ARGS(maybe_throw_overflow_error)

    /* check to see what the behavior is. If the interpreter is set
       to throw an exception on overflow. If so, throw the exception,
       otherwise, chill out it's no big deal. */
    if (PARROT_ERRORS_test(interp, PARROT_ERRORS_OVERFLOW_FLAG))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ERR_OVERFLOW,
            "Integer overflow");
}

PARROT_IGNORABLE_RESULT
PARROT_CANNOT_RETURN_NULL
static PMC*
upgrade_self_to_bignum(PARROT_INTERP, ARGMOD(PMC *self))
{
    ASSERT_ARGS(upgrade_self_to_bignum)

    /* Do an in-place upgrade to a Bignum of SELF and return a pointer
       to it (which is probably redundant, but whatever). */
    const INTVAL a = VTABLE_get_integer(interp, self);
    Parrot_pmc_reuse(interp, self, enum_class_BigInt, 0);
    VTABLE_set_integer_native(interp, self, a);
    return self;
}
#line 97 "./src/pmc/integer.c"
static  PMC  * Parrot_Integer_absolute(PARROT_INTERP, PMC *pmc, PMC *dest);
static  PMC * Parrot_Integer_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_add_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest);
static  PMC  * Parrot_Integer_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL Parrot_Integer_cmp(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL Parrot_Integer_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_decrement(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Integer_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC * Parrot_Integer_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Integer_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  void  Parrot_Integer_freeze(PARROT_INTERP, PMC *pmc, PMC *info);
static  INTVAL  Parrot_Integer_get_bool(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_Integer_get_integer(PARROT_INTERP, PMC *pmc);
static  FLOATVAL  Parrot_Integer_get_number(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Integer_get_repr(PARROT_INTERP, PMC *pmc);
static  STRING  * Parrot_Integer_get_string(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Integer_i_absolute(PARROT_INTERP, PMC *pmc);
static  void Parrot_Integer_i_add(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL b);
static  void Parrot_Integer_i_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Integer_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Integer_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void Parrot_Integer_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b);
static  void Parrot_Integer_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b);
static  void  Parrot_Integer_increment(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Integer_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_Integer_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init);
static  INTVAL  Parrot_Integer_is_equal(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC * Parrot_Integer_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Integer_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest);
static  PMC * Parrot_Integer_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest);
static  void  Parrot_Integer_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Integer_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value);
static  void  Parrot_Integer_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value);
static  void  Parrot_Integer_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value);
static  void  Parrot_Integer_share(PARROT_INTERP, PMC *pmc);
static  PMC * Parrot_Integer_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest);
static  void  Parrot_Integer_thaw(PARROT_INTERP, PMC *pmc, PMC *info);
static  PMC  * Parrot_Integer_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_String_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_floor_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  PMC  * Parrot_Integer_multi_modulus_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  PMC  * Parrot_Integer_multi_modulus_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest);
static  void  Parrot_Integer_multi_i_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value);
static  void  Parrot_Integer_multi_i_modulus_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_String(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_String(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_Float(PARROT_INTERP, PMC *pmc, PMC *value);
static  INTVAL  Parrot_Integer_multi_cmp_num_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value);
static  void Parrot_Integer_nci_get_as_base(PARROT_INTERP, PMC *pmc);
void    Parrot_Integer_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Integer_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Integer_get_vtable(PARROT_INTERP);
void    Parrot_Integer_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Integer_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Integer_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Integer_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1180 "./src/pmc/integer.pmc"

    const INTVAL a = abs(VTABLE_get_integer(interp, pmc));

    /* TT # 1245 overflow for -maxint */
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, a);
    return dest;

#line 211 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_add_Integer_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Complex:
            return Parrot_Integer_multi_add_Complex_PMC(interp, pmc, value, dest);
            break;

        case enum_class_BigInt:
            return Parrot_Integer_multi_add_BigInt_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_add_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_add_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 343 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_add_int(interp, temp, b, dest);
    }
#line 266 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_clone(PARROT_INTERP, PMC *pmc)
{
#line 114 "./src/pmc/integer.pmc"

    PMC * const clone = Parrot_pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, clone, VTABLE_get_integer(interp, pmc));
    return clone;
#line 276 "./src/pmc/integer.c"
}
static  INTVAL
Parrot_Integer_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_String:
            return Parrot_Integer_multi_cmp_String(interp, pmc, value);
            break;

        case enum_class_Float:
            return Parrot_Integer_multi_cmp_Float(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_cmp_DEFAULT(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  INTVAL
Parrot_Integer_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_String:
            return Parrot_Integer_multi_cmp_num_String(interp, pmc, value);
            break;

        case enum_class_Float:
            return Parrot_Integer_multi_cmp_num_Float(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_cmp_num_DEFAULT(interp, pmc, value);
            else {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp_num", "PP->I", pmc, value, &retval);
                return retval;
            }
            break;

    }
}
static  void 
Parrot_Integer_decrement(PARROT_INTERP, PMC *pmc)
{
#line 1154 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - 1;

    if ((c^a) >= 0 || (c^~1) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        Parrot_pmc_reuse(interp, pmc, enum_class_BigInt, 0);
        VTABLE_set_integer_native(interp, pmc, a);
        VTABLE_decrement(interp, pmc);
    }
#line 349 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_divide_BigInt_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_divide_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC *
Parrot_Integer_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_floor_divide_BigInt_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_floor_divide_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "floor_divide", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 837 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 416 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 822 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 435 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_freeze(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 1234 "./src/pmc/integer.pmc"

    interp->vtables[enum_class_default]->freeze(interp, pmc, info);
    VTABLE_push_integer(interp, info, VTABLE_get_integer(interp, pmc));
#line 444 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 185 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, pmc, iv);
    return iv ? 1 : 0;
#line 454 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 169 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, pmc, iv);
    return iv;
#line 464 "./src/pmc/integer.c"
}
static  FLOATVAL 
Parrot_Integer_get_number(PARROT_INTERP, PMC *pmc)
{
#line 201 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, pmc, iv);
    return (FLOATVAL)iv;
#line 474 "./src/pmc/integer.c"
}
static  STRING  *
Parrot_Integer_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 223 "./src/pmc/integer.pmc"

    return Parrot_str_from_int(interp, VTABLE_get_integer(interp, pmc));
#line 482 "./src/pmc/integer.c"
}
static  STRING  *
Parrot_Integer_get_string(PARROT_INTERP, PMC *pmc)
{
#line 219 "./src/pmc/integer.pmc"

    return Parrot_str_from_int(interp, VTABLE_get_integer(interp, pmc));
#line 490 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 1192 "./src/pmc/integer.pmc"

    const INTVAL a = abs(VTABLE_get_integer(interp, pmc));
    VTABLE_set_integer_native(interp, pmc, a);
#line 499 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_add_Integer(interp, pmc, value);
            break;

        case enum_class_Complex:
            Parrot_Integer_multi_i_add_Complex(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_add_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 412 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a + value);
#line 536 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 398 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        maybe_throw_overflow_error(interp);
        pmc = upgrade_self_to_bignum(interp, pmc);
        VTABLE_i_add_int(interp, pmc, b);
    }
#line 553 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_divide_BigInt(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_divide_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void
Parrot_Integer_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_floor_divide_BigInt(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_floor_divide_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_floor_divide", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 883 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 616 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 871 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 631 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_Integer_multi_i_modulus_BigInt(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_modulus_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_modulus", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 998 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(VTABLE_get_integer(interp, pmc) , (INTVAL)value));
#line 668 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 988 "./src/pmc/integer.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(VTABLE_get_integer(interp, pmc) , value));
#line 681 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_multiply_Integer(interp, pmc, value);
            break;

        case enum_class_BigInt:
            Parrot_Integer_multi_i_multiply_BigInt(interp, pmc, value);
            break;

        case enum_class_Complex:
            Parrot_Integer_multi_i_multiply_Complex(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_multiply_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 708 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a * value);
#line 722 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 693 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        maybe_throw_overflow_error(interp);
        upgrade_self_to_bignum(interp, pmc);
        VTABLE_i_multiply_int(interp, pmc, b);
    }
#line 740 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            Parrot_Integer_multi_i_subtract_Integer(interp, pmc, value);
            break;

        case enum_class_Complex:
            Parrot_Integer_multi_i_subtract_Complex(interp, pmc, value);
            break;

        default:
            if (type < enum_class_core_max)
                Parrot_Integer_multi_i_subtract_DEFAULT(interp, pmc, value);
            else {
                
                Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", pmc, value);
                return;
            }
            break;

    }
}
static  void 
Parrot_Integer_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 574 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a - value);
#line 777 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 560 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        maybe_throw_overflow_error(interp);
        pmc = upgrade_self_to_bignum(interp, pmc);
        VTABLE_i_subtract_int(interp, pmc, b);
    }
#line 794 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_increment(PARROT_INTERP, PMC *pmc)
{
#line 1128 "./src/pmc/integer.pmc"

    INTVAL a, c;
    GETATTR_Integer_iv(interp, pmc, a);
    c = a + 1;

    /* did not overflow */
    if ((c^a) >= 0 || (c^1) >= 0)
        SETATTR_Integer_iv(interp, pmc, c);
    else {
        Parrot_pmc_reuse(interp, pmc, enum_class_BigInt, 0);
        VTABLE_set_integer_native(interp, pmc, a);
        VTABLE_increment(interp, pmc);
    }
#line 813 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_init(PARROT_INTERP, PMC *pmc)
{
#line 91 "./src/pmc/integer.pmc"

    Parrot_Integer_attributes * const attrs =
        (Parrot_Integer_attributes *)PMC_data(pmc);

    attrs->iv      = 0;
#line 824 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 98 "./src/pmc/integer.pmc"

    Parrot_Integer_attributes * const attrs =
        (Parrot_Integer_attributes *)PMC_data(pmc);

    attrs->iv      = VTABLE_get_integer(interp, init);
#line 835 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1017 "./src/pmc/integer.pmc"

    INTVAL retval;
    PMC *temp;

    switch (value->vtable->base_type) {
      case enum_class_BigInt:
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, VTABLE_get_integer(interp, pmc));
        Parrot_mmd_multi_dispatch_from_c_args(interp,
                "is_equal", "PP->I", temp, value, &retval);
        return retval;
        break;
      default:
        return (VTABLE_get_integer(interp, pmc)
            ==  VTABLE_get_integer(interp, value));
        break;
    }
#line 858 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_Integer_multi_modulus_BigInt_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_modulus_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "modulus", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 956 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(VTABLE_get_integer(interp, pmc), (INTVAL)value));
    return dest;
#line 898 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 943 "./src/pmc/integer.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(VTABLE_get_integer(interp, pmc), value));
    return dest;
#line 914 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_multiply_Integer_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Complex:
            return Parrot_Integer_multi_multiply_Complex_PMC(interp, pmc, value, dest);
            break;

        case enum_class_BigInt:
            return Parrot_Integer_multi_multiply_BigInt_PMC(interp, pmc, value, dest);
            break;

        case enum_class_String:
            return Parrot_Integer_multi_multiply_String_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_multiply_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 638 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_multiply_int(interp, temp, b, dest);
    }
#line 974 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 266 "./src/pmc/integer.pmc"

    Parrot_pmc_reuse(interp, pmc, enum_class_Boolean, 0);
    VTABLE_set_bool(interp, pmc, value);
#line 983 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 238 "./src/pmc/integer.pmc"

    SETATTR_Integer_iv(interp, pmc, value);
#line 991 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 260 "./src/pmc/integer.pmc"

    Parrot_pmc_reuse(interp, pmc, enum_class_Float, 0);
    VTABLE_set_number_native(interp, pmc, value);
#line 1000 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 130 "./src/pmc/integer.pmc"

    VTABLE_set_integer_native(interp, pmc, VTABLE_get_integer(interp, value));
#line 1008 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 273 "./src/pmc/integer.pmc"

    Parrot_pmc_reuse(interp, pmc, enum_class_String, 0);
    VTABLE_set_string_native(interp, pmc, value);
#line 1017 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_share(PARROT_INTERP, PMC *pmc)
{
#line 145 "./src/pmc/integer.pmc"

    /*
     * assume that the access to a long is atomic.
     * integers are most often (1) equal to C longs,
     * not C ints, and this makes a difference in 64-bit
     * platforms where longs are 64-bit but ints are 32-bit.
     * (1) Not equal when integers have been configured
     *     to be software-emulated long longs.
     */
    if (sizeof (INTVAL) != sizeof (long))
        interp->vtables[enum_class_default]->share(interp, pmc);
#line 1034 "./src/pmc/integer.c"
}
static  PMC *
Parrot_Integer_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, pmc) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Integer:
            return Parrot_Integer_multi_subtract_Integer_PMC(interp, pmc, value, dest);
            break;

        case enum_class_Complex:
            return Parrot_Integer_multi_subtract_Complex_PMC(interp, pmc, value, dest);
            break;

        case enum_class_BigInt:
            return Parrot_Integer_multi_subtract_BigInt_PMC(interp, pmc, value, dest);
            break;

        default:
            if (type < enum_class_core_max)
                return Parrot_Integer_multi_subtract_DEFAULT_PMC(interp, pmc, value, dest);
            else {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", pmc, value, dest, &retval);
                return retval;
            }
            break;

    }
}
static  PMC  *
Parrot_Integer_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 494 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_subtract_int(interp, temp, b, dest);
    }
#line 1089 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_thaw(PARROT_INTERP, PMC *pmc, PMC *info)
{
#line 1249 "./src/pmc/integer.pmc"

    interp->vtables[enum_class_default]->thaw(interp, pmc, info);
    VTABLE_set_integer_native(interp, pmc, VTABLE_shift_integer(interp, info));
#line 1098 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 290 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

        /* need this for e.g. Undef PMC */
        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC * temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_add(interp, temp, value, dest);
    }
#line 1123 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 312 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    dest           = Parrot_pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a + VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            VTABLE_get_number_keyed_int(interp, value, 1));

    return dest;
#line 1139 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 325 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, pmc->vtable->get_integer(interp, pmc));
    return VTABLE_add(interp, temp, value, dest);
#line 1151 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 334 "./src/pmc/integer.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            pmc->vtable->get_integer(interp, pmc) + VTABLE_get_number(interp, value));
    return dest;
#line 1163 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 377 "./src/pmc/integer.pmc"

    Parrot_Integer_i_add_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 1171 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 382 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    UNUSED(a);

    Parrot_pmc_reuse(interp, pmc, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) + VTABLE_get_number(interp, value));
#line 1184 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 392 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) + VTABLE_get_number(interp, value));
#line 1193 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 432 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_subtract(interp, temp, value, dest);
    }
#line 1217 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 453 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    dest           = Parrot_pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));

    return dest;
#line 1233 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 466 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, pmc->vtable->get_integer(interp, pmc));
    return VTABLE_subtract(interp, temp, value, dest);
#line 1245 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 475 "./src/pmc/integer.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_number(interp, value));
    return dest;
#line 1257 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 528 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        maybe_throw_overflow_error(interp);
        pmc = upgrade_self_to_bignum(interp, pmc);
        VTABLE_i_subtract(interp, pmc, value);
    }
#line 1275 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 543 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);

    Parrot_pmc_reuse(interp, pmc, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, pmc,
            (FLOATVAL)a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, pmc, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));
#line 1289 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 554 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_number(interp, value));
#line 1298 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 592 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const INTVAL b  = VTABLE_get_integer(interp, value);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf) {
        dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = Parrot_pmc_new(interp, enum_class_BigInt);
        VTABLE_set_integer_native(interp, temp, a);
        return VTABLE_multiply(interp, temp, value, dest);
    }
#line 1323 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 614 "./src/pmc/integer.pmc"

    return VTABLE_multiply(interp, value, pmc, dest);
#line 1331 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 619 "./src/pmc/integer.pmc"

    return VTABLE_multiply_int(interp, value, pmc->vtable->get_integer(interp, pmc), dest);
#line 1339 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_String_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 624 "./src/pmc/integer.pmc"

    return Parrot_Integer_multi_multiply_Integer_PMC(interp, pmc, value, dest);
#line 1347 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 629 "./src/pmc/integer.pmc"

    const FLOATVAL valf = VTABLE_get_number(interp, value);
    dest                = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, pmc->vtable->get_number(interp, pmc) * valf);
    return dest;
#line 1359 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 672 "./src/pmc/integer.pmc"

    Parrot_Integer_i_multiply_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 1367 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 677 "./src/pmc/integer.pmc"

    interp->vtables[enum_class_BigInt]->multiply_int(interp, value, pmc->vtable->get_integer(interp, pmc), pmc);
#line 1375 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 682 "./src/pmc/integer.pmc"

    VTABLE_multiply(interp, value, pmc, pmc);
#line 1383 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 687 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) * VTABLE_get_number(interp, value));
#line 1392 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 736 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, pmc->vtable->get_integer(interp, pmc));
    return VTABLE_divide(interp, temp, value, dest);
#line 1404 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 744 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));
    VTABLE_set_number_native(interp, dest, pmc->vtable->get_number(interp, pmc) / d);
    return dest;
#line 1420 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 757 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    pmc = upgrade_self_to_bignum(interp, pmc);
    VTABLE_i_divide(interp, pmc, value);
#line 1430 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 764 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    VTABLE_set_number_native(interp, pmc, pmc->vtable->get_number(interp, pmc) / d);
#line 1444 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_floor_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 797 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, pmc->vtable->get_integer(interp, pmc));
    return VTABLE_floor_divide(interp, temp, value, dest);
#line 1456 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 806 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);
    FLOATVAL f;

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    f = floor(pmc->vtable->get_number(interp, pmc) / d);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);
    return dest;
#line 1475 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 852 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    pmc = upgrade_self_to_bignum(interp, pmc);
    VTABLE_i_floor_divide(interp, pmc, value);
#line 1485 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 858 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);
    FLOATVAL f;

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(pmc->vtable->get_number(interp, pmc) / d);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 1501 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_modulus_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 919 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = Parrot_pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, pmc->vtable->get_integer(interp, pmc));
    return VTABLE_modulus(interp, temp, value, dest);
#line 1513 "./src/pmc/integer.c"
}
static  PMC  *
Parrot_Integer_multi_modulus_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 928 "./src/pmc/integer.pmc"

    const INTVAL d = VTABLE_get_integer(interp, value);

    if (d == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(pmc->vtable->get_integer(interp, pmc), d));
    return dest;
#line 1531 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 969 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    pmc = upgrade_self_to_bignum(interp, pmc);
    VTABLE_i_modulus(interp, pmc, value);
#line 1541 "./src/pmc/integer.c"
}
static  void 
Parrot_Integer_multi_i_modulus_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 976 "./src/pmc/integer.pmc"

    const INTVAL d = VTABLE_get_integer(interp, value);

    if (d == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(pmc->vtable->get_integer(interp, pmc), d));
#line 1556 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_String(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1047 "./src/pmc/integer.pmc"

    const FLOATVAL fdiff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(fdiff)) {
        const INTVAL idiff =
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_integer(interp, value);
        return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
    }

    return fdiff > 0 ? 1 : -1;
#line 1572 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1060 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, pmc, iv);

    {
        const FLOATVAL diff = (FLOATVAL)iv - VTABLE_get_number(interp, value);
        return diff > 0 ? 1 : diff < 0 ? -1 : 0;
    }
#line 1586 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1071 "./src/pmc/integer.pmc"

    /* int or undef */
    INTVAL selfint;
    GETATTR_Integer_iv(interp, pmc, selfint);
    {
        const INTVAL valueint = VTABLE_get_integer(interp, value);
        return selfint > valueint ? 1 : selfint < valueint ? -1 : 0;
    }
#line 1600 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_String(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1092 "./src/pmc/integer.pmc"

    const FLOATVAL fdiff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(fdiff)) {
        const INTVAL idiff =
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_integer(interp, value);
        return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
    }

    return fdiff > 0 ? 1 : -1;
#line 1616 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1105 "./src/pmc/integer.pmc"

    const FLOATVAL diff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1625 "./src/pmc/integer.c"
}
static  INTVAL 
Parrot_Integer_multi_cmp_num_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1111 "./src/pmc/integer.pmc"

    /* int or undef */
    const INTVAL diff = pmc->vtable->get_integer(interp, pmc) - VTABLE_get_integer(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1635 "./src/pmc/integer.c"
}
static  void
Parrot_Integer_nci_get_as_base(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 1647 "./src/pmc/integer.pmc"
PMC* pmc;
INTVAL base;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &pmc, &base);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 1209 "./src/pmc/integer.pmc"

    char buf[128];
    STRING *result;

    if ((base < 2) || (base > 36))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "get_as_base: base out of bounds");

    result = Parrot_str_from_int_base(interp, buf,
            (HUGEINTVAL)VTABLE_get_integer(interp, pmc),
            (unsigned int)base);

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)result);
    return;
    /*END RETURN STRING *result */
    }
#line 1221 "./src/pmc/integer.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 1685 "./src/pmc/integer.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Integer_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_Integer_absolute;
    vt->add = Parrot_Integer_add;
    vt->add_int = Parrot_Integer_add_int;
    vt->clone = Parrot_Integer_clone;
    vt->cmp = Parrot_Integer_cmp;
    vt->cmp_num = Parrot_Integer_cmp_num;
    vt->decrement = Parrot_Integer_decrement;
    vt->divide = Parrot_Integer_divide;
    vt->floor_divide = Parrot_Integer_floor_divide;
    vt->floor_divide_float = Parrot_Integer_floor_divide_float;
    vt->floor_divide_int = Parrot_Integer_floor_divide_int;
    vt->freeze = Parrot_Integer_freeze;
    vt->get_bool = Parrot_Integer_get_bool;
    vt->get_integer = Parrot_Integer_get_integer;
    vt->get_number = Parrot_Integer_get_number;
    vt->get_repr = Parrot_Integer_get_repr;
    vt->get_string = Parrot_Integer_get_string;
    vt->i_absolute = Parrot_Integer_i_absolute;
    vt->i_add = Parrot_Integer_i_add;
    vt->i_add_float = Parrot_Integer_i_add_float;
    vt->i_add_int = Parrot_Integer_i_add_int;
    vt->i_divide = Parrot_Integer_i_divide;
    vt->i_floor_divide = Parrot_Integer_i_floor_divide;
    vt->i_floor_divide_float = Parrot_Integer_i_floor_divide_float;
    vt->i_floor_divide_int = Parrot_Integer_i_floor_divide_int;
    vt->i_modulus = Parrot_Integer_i_modulus;
    vt->i_modulus_float = Parrot_Integer_i_modulus_float;
    vt->i_modulus_int = Parrot_Integer_i_modulus_int;
    vt->i_multiply = Parrot_Integer_i_multiply;
    vt->i_multiply_float = Parrot_Integer_i_multiply_float;
    vt->i_multiply_int = Parrot_Integer_i_multiply_int;
    vt->i_subtract = Parrot_Integer_i_subtract;
    vt->i_subtract_float = Parrot_Integer_i_subtract_float;
    vt->i_subtract_int = Parrot_Integer_i_subtract_int;
    vt->increment = Parrot_Integer_increment;
    vt->init = Parrot_Integer_init;
    vt->init_pmc = Parrot_Integer_init_pmc;
    vt->is_equal = Parrot_Integer_is_equal;
    vt->modulus = Parrot_Integer_modulus;
    vt->modulus_float = Parrot_Integer_modulus_float;
    vt->modulus_int = Parrot_Integer_modulus_int;
    vt->multiply = Parrot_Integer_multiply;
    vt->multiply_int = Parrot_Integer_multiply_int;
    vt->set_bool = Parrot_Integer_set_bool;
    vt->set_integer_native = Parrot_Integer_set_integer_native;
    vt->set_number_native = Parrot_Integer_set_number_native;
    vt->set_pmc = Parrot_Integer_set_pmc;
    vt->set_string_native = Parrot_Integer_set_string_native;
    vt->share = Parrot_Integer_share;
    vt->subtract = Parrot_Integer_subtract;
    vt->subtract_int = Parrot_Integer_subtract_int;
    vt->thaw = Parrot_Integer_thaw;
    vt->attr_size = sizeof(Parrot_Integer_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Integer_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_Integer_absolute;
    vt->add = Parrot_Integer_add;
    vt->add_int = Parrot_Integer_add_int;
    vt->clone = Parrot_Integer_clone;
    vt->cmp = Parrot_Integer_cmp;
    vt->cmp_num = Parrot_Integer_cmp_num;
    vt->divide = Parrot_Integer_divide;
    vt->floor_divide = Parrot_Integer_floor_divide;
    vt->floor_divide_float = Parrot_Integer_floor_divide_float;
    vt->floor_divide_int = Parrot_Integer_floor_divide_int;
    vt->freeze = Parrot_Integer_freeze;
    vt->get_bool = Parrot_Integer_get_bool;
    vt->get_integer = Parrot_Integer_get_integer;
    vt->get_number = Parrot_Integer_get_number;
    vt->get_repr = Parrot_Integer_get_repr;
    vt->get_string = Parrot_Integer_get_string;
    vt->init = Parrot_Integer_init;
    vt->init_pmc = Parrot_Integer_init_pmc;
    vt->is_equal = Parrot_Integer_is_equal;
    vt->modulus = Parrot_Integer_modulus;
    vt->modulus_float = Parrot_Integer_modulus_float;
    vt->modulus_int = Parrot_Integer_modulus_int;
    vt->multiply = Parrot_Integer_multiply;
    vt->multiply_int = Parrot_Integer_multiply_int;
    vt->share = Parrot_Integer_share;
    vt->subtract = Parrot_Integer_subtract;
    vt->subtract_int = Parrot_Integer_subtract_int;
    vt->attr_size = sizeof(Parrot_Integer_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Integer_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_scalar_get_vtable(interp);
    Parrot_Integer_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Integer_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_scalar_ro_get_vtable(interp);
    Parrot_Integer_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Integer_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_scalar_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "Integer", 7, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Integer_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_scalar_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Integer")), PMCNULL);
    return isa;
}

void
Parrot_Integer_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iiv ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Integer_get_vtable(interp);
        vt->base_type      = enum_class_Integer;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Integer");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar integer");
        vt->isa_hash     = Parrot_Integer_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_Integer_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_Integer;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Integer_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_Integer_nci_get_as_base), CONST_STRING_GEN(interp, "get_as_base"));
        {
        STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
        STRING * const mfl_1 = CONST_STRING_GEN(interp, "PJPPP");
        STRING * const mfl_2 = CONST_STRING_GEN(interp, "Integer,Integer,PMC");
        STRING * const mfl_3 = CONST_STRING_GEN(interp, "Integer");
        STRING * const mfl_4 = CONST_STRING_GEN(interp, "Integer,Complex,PMC");
        STRING * const mfl_5 = CONST_STRING_GEN(interp, "Integer,BigInt,PMC");
        STRING * const mfl_6 = CONST_STRING_GEN(interp, "Integer,DEFAULT,PMC");
        STRING * const mfl_7 = CONST_STRING_GEN(interp, "i_add");
        STRING * const mfl_8 = CONST_STRING_GEN(interp, "vJPP");
        STRING * const mfl_9 = CONST_STRING_GEN(interp, "Integer,Integer");
        STRING * const mfl_10 = CONST_STRING_GEN(interp, "Integer,Complex");
        STRING * const mfl_11 = CONST_STRING_GEN(interp, "Integer,DEFAULT");
        STRING * const mfl_12 = CONST_STRING_GEN(interp, "subtract");
        STRING * const mfl_13 = CONST_STRING_GEN(interp, "i_subtract");
        STRING * const mfl_14 = CONST_STRING_GEN(interp, "multiply");
        STRING * const mfl_15 = CONST_STRING_GEN(interp, "Integer,String,PMC");
        STRING * const mfl_16 = CONST_STRING_GEN(interp, "i_multiply");
        STRING * const mfl_17 = CONST_STRING_GEN(interp, "Integer,BigInt");
        STRING * const mfl_18 = CONST_STRING_GEN(interp, "divide");
        STRING * const mfl_19 = CONST_STRING_GEN(interp, "i_divide");
        STRING * const mfl_20 = CONST_STRING_GEN(interp, "floor_divide");
        STRING * const mfl_21 = CONST_STRING_GEN(interp, "i_floor_divide");
        STRING * const mfl_22 = CONST_STRING_GEN(interp, "modulus");
        STRING * const mfl_23 = CONST_STRING_GEN(interp, "i_modulus");
        STRING * const mfl_24 = CONST_STRING_GEN(interp, "cmp");
        STRING * const mfl_25 = CONST_STRING_GEN(interp, "IJPP");
        STRING * const mfl_26 = CONST_STRING_GEN(interp, "Integer,String");
        STRING * const mfl_27 = CONST_STRING_GEN(interp, "Integer,Float");
        STRING * const mfl_28 = CONST_STRING_GEN(interp, "cmp_num");

             const  multi_func_list _temp_multi_func_list[] = {
                        { mfl_0,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_add_Integer_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_add_Complex_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_add_BigInt_PMC }
,
        { mfl_0,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_add_DEFAULT_PMC }
,
        { mfl_7,
          mfl_8,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_add_Integer }
,
        { mfl_7,
          mfl_8,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_add_Complex }
,
        { mfl_7,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_add_DEFAULT }
,
        { mfl_12,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_subtract_Integer_PMC }
,
        { mfl_12,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_subtract_Complex_PMC }
,
        { mfl_12,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_subtract_BigInt_PMC }
,
        { mfl_12,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_subtract_DEFAULT_PMC }
,
        { mfl_13,
          mfl_8,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_subtract_Integer }
,
        { mfl_13,
          mfl_8,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_subtract_Complex }
,
        { mfl_13,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_subtract_DEFAULT }
,
        { mfl_14,
          mfl_1,
          mfl_2,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_multiply_Integer_PMC }
,
        { mfl_14,
          mfl_1,
          mfl_4,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_multiply_Complex_PMC }
,
        { mfl_14,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_multiply_BigInt_PMC }
,
        { mfl_14,
          mfl_1,
          mfl_15,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_multiply_String_PMC }
,
        { mfl_14,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_multiply_DEFAULT_PMC }
,
        { mfl_16,
          mfl_8,
          mfl_9,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_multiply_Integer }
,
        { mfl_16,
          mfl_8,
          mfl_17,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_multiply_BigInt }
,
        { mfl_16,
          mfl_8,
          mfl_10,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_multiply_Complex }
,
        { mfl_16,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_multiply_DEFAULT }
,
        { mfl_18,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_divide_BigInt_PMC }
,
        { mfl_18,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_divide_DEFAULT_PMC }
,
        { mfl_19,
          mfl_8,
          mfl_17,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_divide_BigInt }
,
        { mfl_19,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_divide_DEFAULT }
,
        { mfl_20,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_floor_divide_BigInt_PMC }
,
        { mfl_20,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_floor_divide_DEFAULT_PMC }
,
        { mfl_21,
          mfl_8,
          mfl_17,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_floor_divide_BigInt }
,
        { mfl_21,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_floor_divide_DEFAULT }
,
        { mfl_22,
          mfl_1,
          mfl_5,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_modulus_BigInt_PMC }
,
        { mfl_22,
          mfl_1,
          mfl_6,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_modulus_DEFAULT_PMC }
,
        { mfl_23,
          mfl_8,
          mfl_17,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_modulus_BigInt }
,
        { mfl_23,
          mfl_8,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_i_modulus_DEFAULT }
,
        { mfl_24,
          mfl_25,
          mfl_26,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_String }
,
        { mfl_24,
          mfl_25,
          mfl_27,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_Float }
,
        { mfl_24,
          mfl_25,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_DEFAULT }
,
        { mfl_28,
          mfl_25,
          mfl_26,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_num_String }
,
        { mfl_28,
          mfl_25,
          mfl_27,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_num_Float }
,
        { mfl_28,
          mfl_25,
          mfl_11,
          mfl_3,
          (funcptr_t) Parrot_Integer_multi_cmp_num_DEFAULT }

            };
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_Integer_class_init */
#line 1252 "./src/pmc/integer.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
