/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/parrotthread.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_parrotthread.h"
#include "pmc_parrotinterpreter.h"
#include "pmc_default.h"
#include "parrotthread.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/parrotthread.pmc"
/*
Copyright (C) 2001-2010, Parrot Foundation.
$Id: parrotthread.pmc 45292 2010-03-30 01:09:50Z mikehh $

=head1 NAME

src/pmc/parrotthread.pmc - Threaded Interpreter

=head1 DESCRIPTION

ParrotThread extends ParrotInterpreter to provide a threaded interpreter
which supports:

    new P2, "ParrotThread"        # create new threaded interp
    find_method P0, P2, "thread3" # thread-run function
    find_global P5, "_th1"        # locate thread function
    invoke                        # run thread

    set I0, P2                    # get thread id

and these methods:

    thread1
    thread2
    thread3                   # start thread of type 1..3
    join
    detach
    yield
    kill

=head2 Methods

=over 4

=cut

*/

#include "parrot/embed.h"

#define PMC_interp(x) ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->interp

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static INTVAL do_thread_run(PARROT_INTERP,
    ARGIN(PMC *thread),
    INTVAL clone_flags,
    ARGIN(PMC *sub),
    ARGIN(PMC *args))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        __attribute__nonnull__(5);

static void stop_GC(ARGIN(Interp *parent), ARGIN(Interp *thread))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

#define ASSERT_ARGS_do_thread_run __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(thread) \
    , PARROT_ASSERT_ARG(sub) \
    , PARROT_ASSERT_ARG(args))
#define ASSERT_ARGS_stop_GC __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(parent) \
    , PARROT_ASSERT_ARG(thread))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*
 * can't do multi-threaded GC yet
 * XXX a quick hack to pass the few tests
 */
static void
stop_GC(ARGIN(Interp *parent), ARGIN(Interp *thread))
{
    ASSERT_ARGS(stop_GC)
    Parrot_block_GC_mark(parent);
    Parrot_block_GC_mark(thread);
    Parrot_block_GC_sweep(parent);
    Parrot_block_GC_sweep(thread);
}

/* XXX FIXME probably not the best interface [see also list post of
   coke's]
 */

static INTVAL
do_thread_run(PARROT_INTERP, ARGIN(PMC *thread),
                            INTVAL clone_flags, ARGIN(PMC *sub), ARGIN(PMC *args))
{
    ASSERT_ARGS(do_thread_run)

    const INTVAL tid = VTABLE_get_integer(interp, thread);

    if (PMC_IS_NULL(sub)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Invalid thread sub");
    }

    clone_interpreter(PMC_interp(thread), interp, clone_flags);

    interp->flags &= ~PARROT_THR_COPY_INTERP; /* XXX */
    pt_thread_run(interp, thread, sub, args);

    Parrot_pmc_reuse(interp, thread, enum_class_ParrotRunningThread, 0);

    PObj_custom_mark_CLEAR(thread);
    VTABLE_set_integer_native(interp, thread, tid);

    return tid;
}
#line 139 "./src/pmc/parrotthread.c"
static  void  Parrot_ParrotThread_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_ParrotThread_init_pmc(PARROT_INTERP, PMC *pmc, PMC *parent);
static  void Parrot_ParrotThread_nci_run(PARROT_INTERP, PMC *pmc);
static  void Parrot_ParrotThread_nci_run_clone(PARROT_INTERP, PMC *pmc);
void    Parrot_ParrotThread_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ParrotThread_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ParrotThread_get_vtable(PARROT_INTERP);
void    Parrot_ParrotThread_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_ParrotThread_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_ParrotThread_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_ParrotThread_init(PARROT_INTERP, PMC *pmc)
{
#line 155 "./src/pmc/parrotthread.pmc"

    /* protect interpreter creation and list handling */
    LOCK(interpreter_array_mutex);

    interp->vtables[enum_class_ParrotInterpreter]->init(interp, pmc);
    pt_add_to_interpreters(interp, PMC_interp(pmc));

    UNLOCK(interpreter_array_mutex);

    /* can't allow GC runs for now */
    stop_GC(interp, PMC_interp(pmc));
#line 165 "./src/pmc/parrotthread.c"
}
static  void 
Parrot_ParrotThread_init_pmc(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 178 "./src/pmc/parrotthread.pmc"

    LOCK(interpreter_array_mutex);
    interp->vtables[enum_class_ParrotInterpreter]->init_pmc(interp, pmc, parent);

    pt_add_to_interpreters(PMC_interp(parent),
                           PMC_interp(pmc));

    UNLOCK(interpreter_array_mutex);

    /* can't allow GC runs for now */
    stop_GC(interp, PMC_interp(pmc));
#line 182 "./src/pmc/parrotthread.c"
}
static  void
Parrot_ParrotThread_nci_run(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 194 "./src/pmc/parrotthread.pmc"
PMC* pmc;
INTVAL clone_flags;
PMC* sub;
PMC* args;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIPPs",
            &pmc, &clone_flags, &sub, &args);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 134 "./src/pmc/parrotthread.pmc"

    const INTVAL retval = do_thread_run(interp, pmc, clone_flags, sub, args);
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL retval */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)retval);
    return;
    /*END RETURN INTVAL retval */
    }
#line 136 "./src/pmc/parrotthread.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 224 "./src/pmc/parrotthread.c"
}
static  void
Parrot_ParrotThread_nci_run_clone(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 236 "./src/pmc/parrotthread.pmc"
PMC* pmc;
PMC* sub;
PMC* args;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiPPs",
            &pmc, &sub, &args);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 139 "./src/pmc/parrotthread.pmc"

    const INTVAL retval = do_thread_run(interp, pmc, PARROT_CLONE_DEFAULT, sub, args);
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL retval */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)retval);
    return;
    /*END RETURN INTVAL retval */
    }
#line 141 "./src/pmc/parrotthread.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 265 "./src/pmc/parrotthread.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ParrotThread_update_vtable(VTABLE *vt) {
    vt->init = Parrot_ParrotThread_init;
    vt->init_pmc = Parrot_ParrotThread_init_pmc;
    vt->attr_size = 0;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ParrotThread_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->init = Parrot_ParrotThread_init;
    vt->init_pmc = Parrot_ParrotThread_init_pmc;
    vt->attr_size = 0;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ParrotThread_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_ParrotInterpreter_get_vtable(interp);
    Parrot_ParrotThread_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ParrotThread_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_ParrotInterpreter_ro_get_vtable(interp);
    Parrot_ParrotThread_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ParrotThread_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_ParrotInterpreter_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "ParrotThread", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ParrotThread_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_ParrotInterpreter_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ParrotThread")), PMCNULL);
    return isa;
}

void
Parrot_ParrotThread_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":interp Itid Fargs Fsub ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ParrotThread_get_vtable(interp);
        vt->base_type      = enum_class_ParrotThread;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ParrotThread");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_ParrotThread_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_ParrotThread_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_ParrotThread;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ParrotThread_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_ParrotThread_nci_run), CONST_STRING_GEN(interp, "run"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_ParrotThread_nci_run_clone), CONST_STRING_GEN(interp, "run_clone"));
        {
        }
    } /* pass */
} /* Parrot_ParrotThread_class_init */
#line 189 "./src/pmc/parrotthread.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
