/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/stringhandle.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_stringhandle.h"
#include "pmc_handle.h"
#include "pmc_default.h"
#include "stringhandle.str"
#include "pmc/pmc_continuation.h"
#include "pmc/pmc_callcontext.h"
#line 1 "./src/pmc/stringhandle.pmc"
/*
Copyright (C) 2008, Parrot Foundation.
$Id: stringhandle.pmc 45425 2010-04-07 13:38:10Z bacek $

=head1 NAME

src/pmc/stringhandle.pmc - StringHandle PMC

=head1 DESCRIPTION

The StringHandle PMC performs I/O operations, but on an internal string rather
than an external file. Commonly used as a mock FileHandle for testing.

=cut

*/

#include "../src/io/io_private.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_INLINE
static int encoding_is_utf8(PARROT_INTERP, ARGIN_NULLOK(STRING *s))
        __attribute__nonnull__(1);

#define ASSERT_ARGS_encoding_is_utf8 __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=head2 Internal Functions

=over 4

=item C<static int encoding_is_utf8(PARROT_INTERP, STRING *s)>

Helper function for internal usage. Return 1 if the string argument is
not null and has utf8 encoding, 0 otherwise.

=back

=cut

*/

PARROT_INLINE
static int
encoding_is_utf8(PARROT_INTERP, ARGIN_NULLOK(STRING *s))
{
    ASSERT_ARGS(encoding_is_utf8)
    if (STRING_IS_NULL(s))
        return 0;
    else
        return Parrot_str_equal(interp, s, CONST_STRING(interp, "utf8"));
}
#line 84 "./src/pmc/stringhandle.c"
static  PMC  * Parrot_StringHandle_clone(PARROT_INTERP, PMC *pmc);
static  INTVAL  Parrot_StringHandle_get_bool(PARROT_INTERP, PMC *pmc);
static  void  Parrot_StringHandle_init(PARROT_INTERP, PMC *pmc);
static  void  Parrot_StringHandle_mark(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_open(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_is_tty(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_close(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_is_closed(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_read(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_readline(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_readall(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_flush(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_print(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_puts(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_buffer_type(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_buffer_size(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_mode(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_encoding(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_eof(PARROT_INTERP, PMC *pmc);
static  void Parrot_StringHandle_nci_get_fd(PARROT_INTERP, PMC *pmc);
void    Parrot_StringHandle_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_StringHandle_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_StringHandle_get_vtable(PARROT_INTERP);
void    Parrot_StringHandle_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_StringHandle_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_StringHandle_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_StringHandle_clone(PARROT_INTERP, PMC *pmc)
{
#line 107 "./src/pmc/stringhandle.pmc"

    Parrot_StringHandle_attributes * const old_struct  = PARROT_STRINGHANDLE(pmc);
    PMC * const copy = Parrot_pmc_new(interp, enum_class_StringHandle);
    Parrot_StringHandle_attributes * const data_struct = PARROT_STRINGHANDLE(copy);

    if (old_struct->stringhandle != NULL)
        data_struct->stringhandle = Parrot_str_copy(interp, old_struct->stringhandle);
    if (old_struct->mode != NULL)
        data_struct->mode     = Parrot_str_copy(interp, old_struct->mode);
    if (old_struct->encoding != NULL)
        data_struct->encoding = Parrot_str_copy(interp, old_struct->encoding);
    data_struct->flags    = old_struct->flags;

    return copy;
#line 129 "./src/pmc/stringhandle.c"
}
static  INTVAL 
Parrot_StringHandle_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 151 "./src/pmc/stringhandle.pmc"

    STRING *stringhandle;
    GETATTR_StringHandle_stringhandle(interp, pmc, stringhandle);

    if (STRING_IS_NULL(stringhandle))
        return 0;

    return 1;
#line 143 "./src/pmc/stringhandle.c"
}
static  void 
Parrot_StringHandle_init(PARROT_INTERP, PMC *pmc)
{
#line 83 "./src/pmc/stringhandle.pmc"

    Parrot_StringHandle_attributes *data_struct =
            (Parrot_StringHandle_attributes *) PMC_data(pmc);

    data_struct->flags        = 0;
    data_struct->stringhandle = NULL;
    data_struct->mode         = NULL;
    data_struct->encoding     = NULL;
    data_struct->filename     = NULL;
    data_struct->read_offset  = 0;

    PObj_custom_mark_SET(pmc);
#line 161 "./src/pmc/stringhandle.c"
}
static  void 
Parrot_StringHandle_mark(PARROT_INTERP, PMC *pmc)
{
#line 133 "./src/pmc/stringhandle.pmc"

    Parrot_StringHandle_attributes * const data_struct = PARROT_STRINGHANDLE(pmc);
    Parrot_gc_mark_STRING_alive(interp, data_struct->stringhandle);
    Parrot_gc_mark_STRING_alive(interp, data_struct->mode);
    Parrot_gc_mark_STRING_alive(interp, data_struct->encoding);
    Parrot_gc_mark_STRING_alive(interp, data_struct->filename);
#line 173 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_open(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 185 "./src/pmc/stringhandle.pmc"
PMC* pmc;
STRING* filename;
INTVAL got_filename;
STRING* mode;
INTVAL got_mode;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIpSoIp",
            &pmc, &filename, &got_filename, &mode, &got_mode);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 180 "./src/pmc/stringhandle.pmc"

    STRING *open_mode, *old_string;
    INTVAL flags;

    if (got_mode && !STRING_IS_NULL(mode))
        SETATTR_StringHandle_mode(interp, pmc, Parrot_str_copy(interp, mode));

    if (got_filename && !STRING_IS_NULL(filename))
        SETATTR_StringHandle_filename(interp, pmc, Parrot_str_copy(interp, filename));


    /* If StringHandle hasn't already been initialized, create a new string. */
    GETATTR_StringHandle_stringhandle(interp, pmc, old_string);
    if (STRING_IS_NULL(old_string)) {
        STRING *new_string;
        STRING *encoding;

        GETATTR_StringHandle_encoding(interp, pmc, encoding);
        if (encoding_is_utf8(interp, encoding))
            new_string = string_make(interp, "", 0, "unicode", 0);
        else
            new_string = Parrot_str_new(interp, "", 0);

        SETATTR_StringHandle_stringhandle(interp, pmc, new_string);
    }

    /* Set a default mode of read-only. */
    GETATTR_StringHandle_mode(interp, pmc, open_mode);
    if (STRING_IS_NULL(open_mode)) {
        open_mode = Parrot_str_new_constant(interp, "r");
        SETATTR_StringHandle_mode(interp, pmc, open_mode);
    }

    pmc = Parrot_io_open(interp, pmc, filename, open_mode);

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *pmc */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "P", (PMC*)pmc);
    return;
    /*END RETURN PMC *pmc */
    }
#line 215 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 249 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_is_tty(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 261 "./src/pmc/stringhandle.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 227 "./src/pmc/stringhandle.pmc"

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)0);
    return;
    /*END RETURN INTVAL 0 */
    }
#line 228 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 287 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_close(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 299 "./src/pmc/stringhandle.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 242 "./src/pmc/stringhandle.pmc"

    SETATTR_StringHandle_read_offset(interp, pmc, 0);
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)0);
    return;
    /*END RETURN INTVAL 0 */
    }
#line 244 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 326 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_is_closed(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 338 "./src/pmc/stringhandle.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 257 "./src/pmc/stringhandle.pmc"

    INTVAL status;
    status = Parrot_io_is_closed(interp, pmc);
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL status */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)status);
    return;
    /*END RETURN INTVAL status */
    }
#line 260 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 366 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_read(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 378 "./src/pmc/stringhandle.pmc"
PMC* pmc;
INTVAL length;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiI",
            &pmc, &length);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 274 "./src/pmc/stringhandle.pmc"

    STRING *string_result;
    string_result = Parrot_io_reads(interp, pmc, length);
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)string_result);
    return;
    /*END RETURN STRING *string_result */
    }
#line 277 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 407 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_readline(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 419 "./src/pmc/stringhandle.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 291 "./src/pmc/stringhandle.pmc"

    STRING *string_result;
    string_result = Parrot_io_readline(interp, pmc);
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)string_result);
    return;
    /*END RETURN STRING *string_result */
    }
#line 294 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 447 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_readall(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 459 "./src/pmc/stringhandle.pmc"
PMC* pmc;
STRING* name;
INTVAL got_name;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &pmc, &name, &got_name);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 308 "./src/pmc/stringhandle.pmc"

    STRING *string_result;

    GETATTR_StringHandle_stringhandle(interp, pmc, string_result);
    if (STRING_IS_NULL(string_result)) {
        STRING *encoding;
        GETATTR_StringHandle_encoding(interp, pmc, encoding);
        if (encoding_is_utf8(interp, encoding))
            string_result = string_make(interp, "", 0, "unicode", 0);
        else
            string_result = Parrot_str_new_constant(interp, "");
    }
    else
        string_result = Parrot_str_copy(interp, string_result);

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)string_result);
    return;
    /*END RETURN STRING *string_result */
    }
#line 323 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 501 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_flush(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 513 "./src/pmc/stringhandle.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 336 "./src/pmc/stringhandle.pmc"

    Parrot_io_flush(interp, pmc);
#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 529 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_print(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 541 "./src/pmc/stringhandle.pmc"
PMC* pmc;
PMC* to_print;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &pmc, &to_print);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 351 "./src/pmc/stringhandle.pmc"

    STRING * const string_to_print = VTABLE_get_string(interp, to_print);

    Parrot_io_putps(interp, pmc, string_to_print);
#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 560 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_puts(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 572 "./src/pmc/stringhandle.pmc"
PMC* pmc;
STRING* to_print;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &pmc, &to_print);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 367 "./src/pmc/stringhandle.pmc"

    INTVAL flags, status;
    STRING *old_string, *new_string;

    GETATTR_StringHandle_stringhandle(interp, pmc, old_string);
    if (STRING_IS_NULL(old_string))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
            "Cannot write to a closed filehandle");

    GETATTR_StringHandle_flags(interp, pmc, flags);
    if (!(flags & PIO_F_WRITE))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
            "Cannot write to a filehandle not opened for write");

    new_string = Parrot_str_append(interp, old_string, to_print);

    SETATTR_StringHandle_stringhandle(interp, pmc, new_string);

    status = Parrot_str_byte_length(interp, new_string);
    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL status */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)status);
    return;
    /*END RETURN INTVAL status */
    }
#line 386 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 617 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_buffer_type(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 629 "./src/pmc/stringhandle.pmc"
PMC* pmc;
STRING* new_type;
INTVAL got_type;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &pmc, &new_type, &got_type);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 400 "./src/pmc/stringhandle.pmc"

    INTVAL flags;
    STRING * const nobuffer_string   = CONST_STRING(interp, "unbuffered");
    STRING * const linebuffer_string = CONST_STRING(interp, "line-buffered");
    STRING * const fullbuffer_string = CONST_STRING(interp, "full-buffered");

    GETATTR_StringHandle_flags(interp, pmc, flags);

    if (got_type) {
        if (Parrot_str_equal(interp, new_type, nobuffer_string)) {
            flags &= ~ PIO_F_LINEBUF;
            flags &= ~ PIO_F_BLKBUF;
        }
        else if (Parrot_str_equal(interp, new_type, linebuffer_string)) {
            flags |=   PIO_F_LINEBUF;
            flags &= ~ PIO_F_BLKBUF;
        }
        else if (Parrot_str_equal(interp, new_type, fullbuffer_string)) {
            flags &= ~ PIO_F_LINEBUF;
            flags |=   PIO_F_BLKBUF;
        }

        SETATTR_StringHandle_flags(interp, pmc, flags);
    }

    if (flags & PIO_F_LINEBUF)
        #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *linebuffer_string */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)linebuffer_string);
    return;
    /*END RETURN STRING *linebuffer_string */
    }
#line 426 "./src/pmc/stringhandle.pmc"

    else if (flags & PIO_F_BLKBUF)
        #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *fullbuffer_string */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)fullbuffer_string);
    return;
    /*END RETURN STRING *fullbuffer_string */
    }
#line 428 "./src/pmc/stringhandle.pmc"

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *nobuffer_string */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)nobuffer_string);
    return;
    /*END RETURN STRING *nobuffer_string */
    }
#line 429 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 705 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_buffer_size(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 717 "./src/pmc/stringhandle.pmc"
PMC* pmc;
INTVAL new_size;
INTVAL got_size;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiIoIp",
            &pmc, &new_size, &got_size);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 442 "./src/pmc/stringhandle.pmc"

    INTVAL buffer_size;
    STRING *stringhandle;

    GETATTR_StringHandle_stringhandle(interp, pmc, stringhandle);

    if (STRING_IS_NULL(stringhandle))
        #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)0);
    return;
    /*END RETURN INTVAL 0 */
    }
#line 449 "./src/pmc/stringhandle.pmc"

    buffer_size = Parrot_str_byte_length(interp, stringhandle);

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL buffer_size */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)buffer_size);
    return;
    /*END RETURN INTVAL buffer_size */
    }
#line 452 "./src/pmc/stringhandle.pmc"


#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 765 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_mode(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 777 "./src/pmc/stringhandle.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 466 "./src/pmc/stringhandle.pmc"

    STRING *mode, *mode_copy;

    GETATTR_StringHandle_mode(interp, pmc, mode);
    mode_copy = Parrot_str_copy(interp, mode);

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *mode_copy */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)mode_copy);
    return;
    /*END RETURN STRING *mode_copy */
    }
#line 472 "./src/pmc/stringhandle.pmc"


#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 809 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_encoding(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 821 "./src/pmc/stringhandle.pmc"
PMC* pmc;
STRING* new_encoding;
INTVAL got_encoding;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiSoIp",
            &pmc, &new_encoding, &got_encoding);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 487 "./src/pmc/stringhandle.pmc"

    STRING *encoding;
    STRING *encoding_copy = NULL;

    if (got_encoding) {
        if (!STRING_IS_NULL(new_encoding))
            encoding_copy = Parrot_str_copy(interp, new_encoding);
        SETATTR_StringHandle_encoding(interp, pmc, encoding_copy);
        #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *new_encoding */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)new_encoding);
    return;
    /*END RETURN STRING *new_encoding */
    }
#line 495 "./src/pmc/stringhandle.pmc"

    }

    GETATTR_StringHandle_encoding(interp, pmc, encoding);
    if (!STRING_IS_NULL(encoding))
        encoding_copy = Parrot_str_copy(interp, encoding);

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *encoding_copy */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "S", (STRING*)encoding_copy);
    return;
    /*END RETURN STRING *encoding_copy */
    }
#line 502 "./src/pmc/stringhandle.pmc"


#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 874 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_eof(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 886 "./src/pmc/stringhandle.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 517 "./src/pmc/stringhandle.pmc"

    STRING *stringhandle;
    UINTVAL offset;
    GETATTR_StringHandle_stringhandle(interp, pmc, stringhandle);
    GETATTR_StringHandle_read_offset(interp, pmc, offset);

    if (offset >= Parrot_str_byte_length(interp, stringhandle))
        #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 1 */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)1);
    return;
    /*END RETURN INTVAL 1 */
    }
#line 524 "./src/pmc/stringhandle.pmc"


    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)0);
    return;
    /*END RETURN INTVAL 0 */
    }
#line 526 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 930 "./src/pmc/stringhandle.c"
}
static  void
Parrot_StringHandle_nci_get_fd(PARROT_INTERP, PMC *pmc)
{
#line 422 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _ccont       = Parrot_pcc_get_continuation(interp, _ctx);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);
    PMC * _ret_object        = PMCNULL;

    { /* BEGIN PARMS SCOPE */
#line 942 "./src/pmc/stringhandle.pmc"
PMC* pmc;

#line 430 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &pmc);
#line 434 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    { /* BEGIN PMETHOD BODY */
#line 541 "./src/pmc/stringhandle.pmc"

    #line 260 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL -1 */
#line 267 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    _ret_object = Parrot_pcc_build_call_from_c_args(interp, _call_object,
        "I", (INTVAL)-1);
    return;
    /*END RETURN INTVAL -1 */
    }
#line 542 "./src/pmc/stringhandle.pmc"

#line 441 "/home/mandrake/rpm/BUILD/parrot-2.3.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    } /* END PMETHOD BODY */
    } /* END PARAMS SCOPE */
    return;
#line 968 "./src/pmc/stringhandle.c"
}
#include "pmc/pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_StringHandle_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_StringHandle_clone;
    vt->get_bool = Parrot_StringHandle_get_bool;
    vt->init = Parrot_StringHandle_init;
    vt->mark = Parrot_StringHandle_mark;
    vt->attr_size = sizeof(Parrot_StringHandle_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_StringHandle_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_StringHandle_clone;
    vt->get_bool = Parrot_StringHandle_get_bool;
    vt->init = Parrot_StringHandle_init;
    vt->mark = Parrot_StringHandle_mark;
    vt->attr_size = sizeof(Parrot_StringHandle_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StringHandle_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_get_vtable(interp);
    Parrot_StringHandle_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_StringHandle_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Handle_ro_get_vtable(interp);
    Parrot_StringHandle_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_StringHandle_get_mro(PARROT_INTERP, PMC* mro) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Handle_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro,
        string_make(interp, "StringHandle", 12, NULL, 0));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_StringHandle_get_isa(PARROT_INTERP, Hash* isa) {
    if (isa == NULL) {
        isa = parrot_new_hash(interp);
    }
    isa = Parrot_Handle_get_isa(interp, isa);

    parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "StringHandle")), PMCNULL);
    return isa;
}

void
Parrot_StringHandle_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":os_handle Iflags Sstringhandle Smode Sencoding Sfilename Iread_offset ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_StringHandle_get_vtable(interp);
        vt->base_type      = enum_class_StringHandle;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "StringHandle");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_StringHandle_get_isa(interp, NULL);
        {
            VTABLE                   *vt_ro;
            vt_ro                 = Parrot_StringHandle_ro_get_vtable(interp);
            vt_ro->base_type      = enum_class_StringHandle;
            vt_ro->flags          = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable      = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_StringHandle_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_open), CONST_STRING_GEN(interp, "open"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_is_tty), CONST_STRING_GEN(interp, "is_tty"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_close), CONST_STRING_GEN(interp, "close"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_is_closed), CONST_STRING_GEN(interp, "is_closed"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_read), CONST_STRING_GEN(interp, "read"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_readline), CONST_STRING_GEN(interp, "readline"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_readall), CONST_STRING_GEN(interp, "readall"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_flush), CONST_STRING_GEN(interp, "flush"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_print), CONST_STRING_GEN(interp, "print"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_puts), CONST_STRING_GEN(interp, "puts"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_buffer_type), CONST_STRING_GEN(interp, "buffer_type"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_buffer_size), CONST_STRING_GEN(interp, "buffer_size"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_mode), CONST_STRING_GEN(interp, "mode"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_encoding), CONST_STRING_GEN(interp, "encoding"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_eof), CONST_STRING_GEN(interp, "eof"));
        register_raw_nci_method_in_ns(interp, entry, F2DPTR(Parrot_StringHandle_nci_get_fd), CONST_STRING_GEN(interp, "get_fd"));
        {
        }
    } /* pass */
} /* Parrot_StringHandle_class_init */
#line 553 "./src/pmc/stringhandle.pmc"
 /* end pmclass */

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
